// ATX Trespasser 2.00+ Plugin System
// Trespasser Class VTable Interface Structures (complex classes emulated using simple structures)
//
// Notes:
// - Class sizes should not be determined using this file. It exists to determine inheritance
//   patterns and some structures only. Do not attempt to access instance members in empty classes by typecast unless
//   you have gone through the ATX source, have hacked successfully, and know what you are doing.
// - The CUIListBox class is only declared once here, but in reality has two occurrences.
//   Not very useful anyhow.
// - Using the lpVTable pointers to access instances' class VTables is probably not a good idea
//   for most languages, as pointers contained in VTables designate methods which require the "thiscall" calling
//   convention (the 'this' pointer passed in the ecx register, other params passed as stdcall). I
//   do not know of any way to force this calling convention properly in C/C++ (when trying to call them as
//   standard functions from pointers) other than using pure inline/external assembly code.
//   I would highly recommend using ATX plugin library functions whenever possible instead.
// - This structure for this file was generated using the rudimentary "CLVT" utility.
//   See ATX_SOURCE\standalone\tresclassgenerator\README.txt for rudimentary documentation.
//   Don't use it unless you really have to (i.e., translating to another language).


#ifndef atxtresclassdefsH
#define atxtresclassdefsH


// STANDARD CLASSES

typedef struct CBaseValue {
	void *lpVTable;                               // 0x000
} CBaseValue;

typedef struct CUICtrl {
	void *lpVTable;                               // 0x000
} CUICtrl;

typedef struct CUICtrlCallback {
	void *lpVTable;                               // 0x000
} CUICtrlCallback;

typedef struct CMultiBase {
	void *lpVTable;                               // 0x000
} CMultiBase;

typedef struct CMessage {
	void *lpVTable;                               // 0x000
} CMessage;

typedef struct CErrorDlg {
	void *lpVTable;                               // 0x000
} CErrorDlg;

typedef struct CMainWnd {
	void *lpVTable;                               // 0x000
} CMainWnd;

typedef struct CRefObj {
	void *lpVTable;                               // 0x000
} CRefObj;

typedef struct CPartition {
	void *lpVTable;                               // 0x000
} CPartition;

typedef struct CCAULoad {
	void *lpVTable;                               // 0x000
} CCAULoad;

typedef struct CRandom {
	void *lpVTable;                               // 0x000
} CRandom;

typedef struct CBoundVol {
	void *lpVTable;                               // 0x000
} CBoundVol;

typedef struct CExpressionEvaluate {
	void *lpVTable;                               // 0x000
} CExpressionEvaluate;

typedef struct CProfileStat {
	void *lpVTable;                               // 0x000
} CProfileStat;

typedef struct CScreenRender {
	void *lpVTable;                               // 0x000
} CScreenRender;

typedef struct CClipPlane {
	void *lpVTable;                               // 0x000
} CClipPlane;

typedef struct CPixelFormat {
	void *lpVTable;                               // 0x000
} CPixelFormat;

typedef struct CMagnetPair {
	void *lpVTable;                               // 0x000
} CMagnetPair;

typedef struct CRasterPool {
	void *lpVTable;                               // 0x000
} CRasterPool;

typedef struct CParticleBase {
	void *lpVTable;                               // 0x000
} CParticleBase;

typedef struct CConsoleBuffer {
	void *lpVTable;                               // 0x000
} CConsoleBuffer;

typedef struct CInfo {
	void *lpVTable;                               // 0x000
} CInfo;

typedef struct CAnimationScript {
	void *lpVTable;                               // 0x000
} CAnimationScript;

typedef struct CSynthesizer {
	void *lpVTable;                               // 0x000
} CSynthesizer;

typedef struct CBrain {
	void *lpVTable;                               // 0x000
} CBrain;

typedef struct CMentalState {
	void *lpVTable;                               // 0x000
} CMentalState;

typedef struct CActivity {
	void *lpVTable;                               // 0x000
} CActivity;

typedef struct CNodeSource {
	void *lpVTable;                               // 0x000
} CNodeSource;

typedef struct CWorldView {
	void *lpVTable;                               // 0x000
} CWorldView;

typedef struct CWaveData {
	void *lpVTable;                               // 0x000
} CWaveData;

typedef struct CUIButton : public CUICtrl {
} CUIButton;

typedef struct CUIStatic : public CUICtrl {
} CUIStatic;

typedef struct CUICheckbox : public CUICtrl {
} CUICheckbox;

typedef struct CUITextbox : public CUICtrl {
} CUITextbox;

typedef struct CUISlider : public CUICtrl {
} CUISlider;

typedef struct CUIEditbox : public CUICtrl {
} CUIEditbox;

typedef struct CUIProgressBar : public CUICtrl {
} CUIProgressBar;

typedef struct CUIHotspot : public CUICtrl {
} CUIHotspot;

typedef struct CUIWnd : public CUICtrlCallback {
} CUIWnd;

typedef struct CAudioPCM : public CCAULoad {
} CAudioPCM;

typedef struct CAudioADPCM : public CCAULoad {
} CAudioADPCM;

typedef struct CBoundVolBox : public CBoundVol {
} CBoundVolBox;

typedef struct CBoundVolSphere : public CBoundVol {
} CBoundVolSphere;

typedef struct CAction : public CRefObj {
} CAction;

typedef struct CBoundVolInfinite : public CBoundVol {
} CBoundVolInfinite;

typedef struct CScreenRenderTerrain : public CScreenRender {
} CScreenRenderTerrain;

typedef struct CProfileStatMain : public CProfileStat {
} CProfileStatMain;

typedef struct CPartitionSpace : public CPartition {
} CPartitionSpace;

typedef struct CBoundVolPolyhedron : public CBoundVol {
} CBoundVolPolyhedron;

typedef struct CTexturePageManager : public CRefObj {
} CTexturePageManager;

typedef struct CPackedRaster : public CRefObj {
} CPackedRaster;

typedef struct CBoolValue : public CBaseValue {
} CBoolValue;

typedef struct CCharValue : public CBaseValue {
} CCharValue;

typedef struct CIntValue : public CBaseValue {
} CIntValue;

typedef struct CFloatValue : public CBaseValue {
} CFloatValue;

typedef struct CStringValue : public CBaseValue {
} CStringValue;

typedef struct CObjectValue : public CBaseValue {
} CObjectValue;

typedef struct CValueTable {
	void *lpVTable;                               // 0x000
} CValueTable;

typedef struct CPixelFormatBumpmap : public CPixelFormat {
} CPixelFormatBumpmap;

typedef struct CBoundVolPoint : public CBoundVol {
} CBoundVolPoint;

typedef struct CPixelFormat4444 : public CPixelFormat {
} CPixelFormat4444;

typedef struct CPixelFormat888 : public CPixelFormat {
} CPixelFormat888;

typedef struct CPixelFormatPalette : public CPixelFormat {
} CPixelFormatPalette;

typedef struct CPixelFormat555 : public CPixelFormat {
} CPixelFormat555;

typedef struct CPixelFormat565 : public CPixelFormat {
} CPixelFormat565;

typedef struct CTexture : public CRefObj {
} CTexture;

typedef struct CScreenRenderShadowLight : public CScreenRender {
} CScreenRenderShadowLight;

typedef struct CParticleFluid : public CParticleBase {
} CParticleFluid;

typedef struct CParticleSolid : public CParticleBase {
} CParticleSolid;

typedef struct CScheduleCache {
	void *lpVTable;                               // 0x000
} CScheduleCache;

typedef struct CRenderCacheLRU {
	void *lpVTable;                               // 0x000
} CRenderCacheLRU;

typedef struct CRenderDescDWI {
	void *lpVTable;                               // 0x000
} CRenderDescDWI;

typedef struct CScreenRenderDWI : public CScreenRender {
} CScreenRenderDWI;

typedef struct CTimerLocal {
	void *lpVTable;                               // 0x000
} CTimerLocal;

typedef struct CConsoleEx : public CConsoleBuffer {
} CConsoleEx;

typedef struct CMessageDelete : public CMessage {
} CMessageDelete;

typedef struct CMessageCreate : public CMessage {
} CMessageCreate;

typedef struct CAIInfo : public CRefObj {
} CAIInfo;

typedef struct CActivityCompound : public CActivity {
} CActivityCompound;

typedef struct CTerrainKnowledge : public CNodeSource {
} CTerrainKnowledge;

typedef struct CInfluence : public CNodeSource {
} CInfluence;

typedef struct CAIGraph {
	void *lpVTable;                               // 0x000
} CAIGraph;

typedef struct CNHInvalid {
	void *lpVTable;                               // 0x000
} CNHInvalid;

typedef struct CNHStop {
	void *lpVTable;                               // 0x000
} CNHStop;

typedef struct CNHStart {
	void *lpVTable;                               // 0x000
} CNHStart;

typedef struct CPathAStar {
	void *lpVTable;                               // 0x000
} CPathAStar;

typedef struct CActivityDistance : public CActivity {
} CActivityDistance;

typedef struct CActivityVocal : public CActivity {
} CActivityVocal;

typedef struct CActivityGlare : public CActivity {
} CActivityGlare;

typedef struct CActivityCockHead : public CActivity {
} CActivityCockHead;

typedef struct CActivityLookAround : public CActivity {
} CActivityLookAround;

typedef struct CActivityRearBack : public CActivity {
} CActivityRearBack;

typedef struct CActivityCower : public CActivity {
} CActivityCower;

typedef struct CActivityNothing : public CActivity {
} CActivityNothing;

typedef struct CActivityMoveHintWander : public CActivity {
} CActivityMoveHintWander;

typedef struct CActivityMoveCommandStayNear : public CActivity {
} CActivityMoveCommandStayNear;

typedef struct CActivityMoveCommandStayAway : public CActivity {
} CActivityMoveCommandStayAway;

typedef struct CActivityJumpBack : public CActivity {
} CActivityJumpBack;

typedef struct CActivityGetOut : public CActivity {
} CActivityGetOut;

typedef struct CActivityBite : public CActivity {
} CActivityBite;

typedef struct CActivityRam : public CActivity {
} CActivityRam;

typedef struct CActivityPhased : public CActivity {
} CActivityPhased;

typedef struct CNHInfluence {
	void *lpVTable;                               // 0x000
} CNHInfluence;

typedef struct CNHNodeSource {
	void *lpVTable;                               // 0x000
} CNHNodeSource;

typedef struct CAStarAIGraph {
	void *lpVTable;                               // 0x000
} CAStarAIGraph;

typedef struct CNHRandom {
	void *lpVTable;                               // 0x000
} CNHRandom;

typedef struct CBoundVolCamera : public CBoundVol {
} CBoundVolCamera;

typedef struct CSimWave2D : public CWaveData {
} CSimWave2D;

typedef struct CUIListbox : public CUICtrl {
} CUIListbox;

typedef struct CConfigureWnd : public CMultiBase {
} CConfigureWnd;

typedef struct CUIDlg : public CUIWnd {
} CUIDlg;

typedef struct CGameWnd : public CUIWnd {
} CGameWnd;

typedef struct CMessageSystem : public CMessage {
} CMessageSystem;

typedef struct CRasterBase : public CRefObj {
} CRasterBase;

typedef struct CVideoWnd : public CUIWnd {
} CVideoWnd;

typedef struct CInstance : public CPartition {
} CInstance;

typedef struct CMessageAudio : public CMessage {
} CMessageAudio;

typedef struct CRenderType : public CRefObj {
} CRenderType;

typedef struct CMessagePickUp : public CMessage {
} CMessagePickUp;

typedef struct CMessagePhysicsReq : public CMessage {
} CMessagePhysicsReq;

typedef struct CMessageUse : public CMessage {
} CMessageUse;

typedef struct CMessagePaint : public CMessage {
} CMessagePaint;

typedef struct CSetAIAction : public CAction {
} CSetAIAction;

typedef struct CWakeAIAction : public CAction {
} CWakeAIAction;

typedef struct CSetPhysicsAction : public CAction {
} CSetPhysicsAction;

typedef struct CSubstituteMeshAction : public CAction {
} CSubstituteMeshAction;

typedef struct CMagnetAction : public CAction {
} CMagnetAction;

typedef struct CAnimateTextureAction : public CAction {
} CAnimateTextureAction;

typedef struct CHideShowAction : public CAction {
} CHideShowAction;

typedef struct CSetHintAction : public CAction {
} CSetHintAction;

typedef struct CSubstituteAIAction : public CAction {
} CSubstituteAIAction;

typedef struct CEndGameAction : public CAction {
} CEndGameAction;

typedef struct CControlPlayerAction : public CAction {
} CControlPlayerAction;

typedef struct CAISystemAction : public CAction {
} CAISystemAction;

typedef struct CWaterDisturbanceAction : public CAction {
} CWaterDisturbanceAction;

typedef struct CMessageTrigger : public CMessage {
} CMessageTrigger;

typedef struct CVoiceOverAction : public CAction {
} CVoiceOverAction;

typedef struct CAmbientAction : public CAction {
} CAmbientAction;

typedef struct CMusicAction : public CAction {
} CMusicAction;

typedef struct CFadeMusicAction : public CAction {
} CFadeMusicAction;

typedef struct CShowOverlayAction : public CAction {
} CShowOverlayAction;

typedef struct CSetFogAction : public CAction {
} CSetFogAction;

typedef struct CSetTerrainAction : public CAction {
} CSetTerrainAction;

typedef struct CSetSortAction : public CAction {
} CSetSortAction;

typedef struct CSetRendererAction : public CAction {
} CSetRendererAction;

typedef struct CSetImageCacheAction : public CAction {
} CSetImageCacheAction;

typedef struct CSetSkyAction : public CAction {
} CSetSkyAction;

typedef struct CSetAlphaWaterAction : public CAction {
} CSetAlphaWaterAction;

typedef struct CWaterOnOffAction : public CAction {
} CWaterOnOffAction;

typedef struct CLoadLevelAction : public CAction {
} CLoadLevelAction;

typedef struct CSaveLevelAction : public CAction {
} CSaveLevelAction;

typedef struct CSetAnimatePropertiesAction : public CAction {
} CSetAnimatePropertiesAction;

typedef struct CTeleportAction : public CAction {
} CTeleportAction;

typedef struct CSoundEffectAction : public CAction {
} CSoundEffectAction;

typedef struct CDelayAction : public CAction {
} CDelayAction;

typedef struct CScriptedAnimationAction : public CAction {
} CScriptedAnimationAction;

typedef struct CSetVariableTriggerAction : public CAction {
} CSetVariableTriggerAction;

typedef struct CAudioEnvironmentAction : public CAction {
} CAudioEnvironmentAction;

typedef struct CTextAction : public CAction {
} CTextAction;

typedef struct CPhysicsInfo : public CRefObj {
} CPhysicsInfo;

typedef struct TPartitionListChild {
	void *lpVTable;                               // 0x000
} TPartitionListChild;

typedef struct CPartitionSpaceQuery : public CPartitionSpace {
} CPartitionSpaceQuery;

typedef struct CPage : public CPackedRaster {
} CPage;

typedef struct CMessageMove : public CMessage {
} CMessageMove;

typedef struct CParticleDust : public CParticleSolid {
} CParticleDust;

typedef struct CMessageStep : public CMessage {
} CMessageStep;

typedef struct CMessageCollision : public CMessage {
} CMessageCollision;

typedef struct TPartitionList {
	void *lpVTable;                               // 0x000
} TPartitionList;

typedef struct CMessageDamage : public CMessage {
} CMessageDamage;

typedef struct CMessageDeath : public CMessage {
} CMessageDeath;

typedef struct CActivityExclusive : public CActivityCompound {
} CActivityExclusive;

typedef struct CActivityDOSubBrain : public CActivityCompound {
} CActivityDOSubBrain;

typedef struct CActivitySniffAir : public CActivityVocal {
} CActivitySniffAir;

typedef struct CActivityMoveCommandToward : public CActivityDistance {
} CActivityMoveCommandToward;

typedef struct CActivityPursue : public CActivityDistance {
} CActivityPursue;

typedef struct CActivityFlee : public CActivityDistance {
} CActivityFlee;

typedef struct CActivityApproach : public CActivityDistance {
} CActivityApproach;

typedef struct CActivityMoveBy : public CActivityDistance {
} CActivityMoveBy;

typedef struct CActivityVocalSnarl : public CActivityVocal {
} CActivityVocalSnarl;

typedef struct CActivityVocalCroon : public CActivityVocal {
} CActivityVocalCroon;

typedef struct CActivityFeint : public CActivityBite {
} CActivityFeint;

typedef struct CActivityEat : public CActivityPhased {
} CActivityEat;

typedef struct CActivityDrink : public CActivityPhased {
} CActivityDrink;

typedef struct CActivityTailSwipe : public CActivityPhased {
} CActivityTailSwipe;

typedef struct CNHInfluenceSurface : public CNHInfluence {
} CNHInfluenceSurface;

typedef struct CSimWaveVar2D : public CSimWave2D {
} CSimWaveVar2D;

typedef struct CRenderWnd : public CUIDlg {
} CRenderWnd;

typedef struct CMsgDlg : public CUIDlg {
} CMsgDlg;

typedef struct CControlsWnd : public CUIDlg {
} CControlsWnd;

typedef struct CRaster : public CRasterBase {
} CRaster;

typedef struct CLoadGameWnd : public CUIDlg {
} CLoadGameWnd;

typedef struct CSaveGameWnd : public CUIDlg {
} CSaveGameWnd;

typedef struct CMainScreenWnd : public CUIDlg {
} CMainScreenWnd;

typedef struct CLoaderWnd : public CUIDlg {
} CLoaderWnd;

typedef struct CDirectLoadWnd : public CUIDlg {
} CDirectLoadWnd;

typedef struct CQuitWnd : public CUIDlg {
} CQuitWnd;

typedef struct COptionsWnd : public CUIDlg {
} COptionsWnd;

typedef struct CInGameOptionsWnd : public CUIDlg {
} CInGameOptionsWnd;

typedef struct CAudioWnd : public CUIDlg {
} CAudioWnd;

typedef struct CHintWnd : public CUIDlg {
} CHintWnd;

typedef struct CEntity : public CInstance {
} CEntity;

typedef struct CMuzzleFlash : public CInstance {
} CMuzzleFlash;

typedef struct CLight : public CRenderType {
} CLight;

typedef struct CPhysicsInfoTerrain : public CPhysicsInfo {
} CPhysicsInfoTerrain;

typedef struct CShape : public CRenderType {
} CShape;

typedef struct CTerrainObj : public CInstance {
} CTerrainObj;

typedef struct CInvisibleShape : public CRenderType {
} CInvisibleShape;

typedef struct CPhysicsInfoSkeleton : public CPhysicsInfo {
} CPhysicsInfoSkeleton;

typedef struct CPhysicsInfoBox : public CPhysicsInfo {
} CPhysicsInfoBox;

typedef struct CPhysicsInfoCompound : public CPhysicsInfo {
} CPhysicsInfoCompound;

typedef struct CMessageControl : public CMessage {
} CMessageControl;

typedef struct CBoundaryBox : public CInstance {
} CBoundaryBox;

typedef struct CPhysicsInfoWater : public CPhysicsInfo {
} CPhysicsInfoWater;

typedef struct CBackdrop : public CInstance {
} CBackdrop;

typedef struct CWDbQueryLights {
	void *lpVTable;                               // 0x000
} CWDbQueryLights;

typedef struct CWDbQueryPhysics {
	void *lpVTable;                               // 0x000
} CWDbQueryPhysics;

typedef struct CWDbQueryPhysicsMovable {
	void *lpVTable;                               // 0x000
} CWDbQueryPhysicsMovable;

typedef struct CWDbQueryPhysicsBoxFast {
	void *lpVTable;                               // 0x000
} CWDbQueryPhysicsBoxFast;

typedef struct CWDbQueryWater {
	void *lpVTable;                               // 0x000
} CWDbQueryWater;

typedef struct CWDbQueryAI {
	void *lpVTable;                               // 0x000
} CWDbQueryAI;

typedef struct CWDbQueryActiveEntities {
	void *lpVTable;                               // 0x000
} CWDbQueryActiveEntities;

typedef struct CActivitySniffTarget : public CActivitySniffAir {
} CActivitySniffTarget;

typedef struct CSocket : public CInstance {
} CSocket;

typedef struct CSimWater2D : public CSimWaveVar2D {
} CSimWater2D;

typedef struct CYesNo : public CMsgDlg {
} CYesNo;

typedef struct CRasterDC : public CRaster {
} CRasterDC;

typedef struct COKDlg : public CMsgDlg {
} COKDlg;

typedef struct CSubsystem : public CEntity {
} CSubsystem;

typedef struct CGun : public CEntity {
} CGun;

typedef struct CAnimate : public CEntity {
} CAnimate;

typedef struct CTrigger : public CEntity {
} CTrigger;

typedef struct CLightAmbient : public CLight {
} CLightAmbient;

typedef struct CEntityWater : public CEntity {
} CEntityWater;

typedef struct CFastHeap {
	void *lpVTable;                               // 0x000
} CFastHeap;

typedef struct CMesh : public CShape {
} CMesh;

typedef struct CMeshCache : public CShape {
} CMeshCache;

typedef struct CPhysicsInfoHuman : public CPhysicsInfoSkeleton {
} CPhysicsInfoHuman;

typedef struct CPhysicsInfoBiped : public CPhysicsInfoSkeleton {
} CPhysicsInfoBiped;

typedef struct CRasterVid : public CRaster {
} CRasterVid;

typedef struct CRasterMem : public CRaster {
} CRasterMem;

typedef struct CRasterD3D : public CRaster {
} CRasterD3D;

typedef struct CEntityAttached : public CEntity {
} CEntityAttached;

typedef struct CTeleport : public CEntity {
} CTeleport;

typedef struct CBoundVolCameraParallel : public CBoundVolCamera {
} CBoundVolCameraParallel;

typedef struct CBoundVolCameraParallelOpen : public CBoundVolCamera {
} CBoundVolCameraParallelOpen;

typedef struct CWaterDisturbance : public CEntity {
} CWaterDisturbance;

typedef struct CYesNoMsgDlg : public CYesNo {
} CYesNoMsgDlg;

typedef struct CYesNoTextDlg : public CYesNo {
} CYesNoTextDlg;

typedef struct CMsgOkDlg : public COKDlg {
} CMsgOkDlg;

typedef struct CRasterWin : public CRasterVid {
} CRasterWin;

typedef struct CAudioDaemon : public CSubsystem {
} CAudioDaemon;

typedef struct CPlayer : public CAnimate {
} CPlayer;

typedef struct CTextOverlay : public CSubsystem {
} CTextOverlay;

typedef struct CVariableTrigger : public CTrigger {
} CVariableTrigger;

typedef struct CDaemon : public CSubsystem {
} CDaemon;

typedef struct CVideoOverlay : public CSubsystem {
} CVideoOverlay;

typedef struct CTerrain : public CSubsystem {
} CTerrain;

typedef struct CCamera : public CEntityAttached {
} CCamera;

typedef struct CMeshAnimating : public CMesh {
} CMeshAnimating;

typedef struct CMeshPlanted : public CMesh {
} CMeshPlanted;

typedef struct CPhysicsSystem : public CSubsystem {
} CPhysicsSystem;

typedef struct CPhysicsInfoPlayer : public CPhysicsInfoHuman {
} CPhysicsInfoPlayer;

typedef struct CPhysicsInfoQuadruped : public CPhysicsInfoBiped {
} CPhysicsInfoQuadruped;

typedef struct CLightDir : public CLightAmbient {
} CLightDir;

typedef struct CClipPlaneTolerance : public CClipPlane {
} CClipPlaneTolerance;

typedef struct CShapeCache : public CMeshCache {
} CShapeCache;

typedef struct CInputDeemone : public CSubsystem {
} CInputDeemone;

typedef struct CMeshLightDir : public CMesh {
} CMeshLightDir;

typedef struct CWDbQueryTerrainObj : public TPartitionList {
} CWDbQueryTerrainObj;

typedef struct CAnimal : public CAnimate {
} CAnimal;

typedef struct CAnimations : public CSubsystem {
} CAnimations;

typedef struct CCameraPrime : public CSubsystem {
} CCameraPrime;

typedef struct CRenderDB : public CSubsystem {
} CRenderDB;

typedef struct CEntityLight : public CEntityAttached {
} CEntityLight;

typedef struct CAISystem : public CSubsystem {
} CAISystem;

typedef struct CBloodSplats : public CSubsystem {
} CBloodSplats;

typedef struct CMoreMassTrigger : public CTrigger {
} CMoreMassTrigger;

typedef struct CObjectTrigger : public CTrigger {
} CObjectTrigger;

typedef struct CTimerTrigger : public CTrigger {
} CTimerTrigger;

typedef struct CBooleanTrigger : public CTrigger {
} CBooleanTrigger;

typedef struct CSequenceTrigger : public CTrigger {
} CSequenceTrigger;

typedef struct CCreatureTrigger : public CTrigger {
} CCreatureTrigger;

typedef struct CStartTrigger : public CTrigger {
} CStartTrigger;

typedef struct CCollisionTrigger : public CTrigger {
} CCollisionTrigger;

typedef struct CLocationTrigger : public CTrigger {
} CLocationTrigger;

typedef struct CClipPlaneNull : public CClipPlane {
} CClipPlaneNull;

typedef struct CAutoGrabber : public CSubsystem {
} CAutoGrabber;

typedef struct CPlayerPriv : public CPlayer {
} CPlayerPriv;

typedef struct CBioMesh : public CMeshAnimating {
} CBioMesh;

typedef struct CLightDirectional : public CLightDir {
} CLightDirectional;

typedef struct CSubBioMesh : public CBioMesh {
} CSubBioMesh;

typedef struct CShadowBuffer : public CRasterMem {
} CShadowBuffer;

typedef struct CBumpMap : public CRasterMem {
} CBumpMap;


// OTHER CLASSES

typedef struct CParticleQualities {
	       float Number;                   // default = 8.0
	       float unknownRadians;           // ??? default = 6.283185 (pi*2) **
	       float Size;                     // default = 0.01
	       float Length;                   // default = 0.04
	       float Velocity;                 // default = 4.0
	       float Lifespan;                 // default = 1.0
	       float StuckGravity;             // default = 1.0 NOT "GravityStuck" ***
	       float Gravity;                  // default = 5.0
	       float SpreadRadians;            // default = 1.047198 (radians) - This is the T-Script "Spread" float value converted to radians
	       float Threshold;                // default = 1.0
	} CParticleQualities;

#define CPARTICLES_TYPE_SOLID			0	// if bool Solid = true
#define CPARTICLES_TYPE_DUST			1	// if bool Dust = true (has priority over CPARTICLES_TYPE_SOLID in construction)
#define CPARTICLES_TYPE_FLUID			2	// default

typedef struct CParticles {
	       uint Type;                       // default = CPARTICLES_TYPE_FLUID
	       uint ColorRGB;                   // format: 0x00RRGGBB
	       uint Flags1;                     // default = 0
	       uint Log;                        // lower byte corresponds to T-Script bool "Log" value (default = TRUE)
	       float unknownFloat;              // usually 0.25
	       uint Priority;
	       CParticleQualities Min;          // defaults: all values 0.0
	       CParticleQualities Max;          // defaults: as described in CParticleQualities comments
	       void *lpEffectNameDesc;          // seems unused
	       uint unknownInt;                 // seems unused
	} CParticles;


#endif
