;==========================================================
proc CreateLogFile uses ebx, lpFileNamePath, lpHeaderStr, HeaderStrLen
;==========================================================

   local dwTemp:DWORD

	invoke CreateFile,[lpFileNamePath],GENERIC_WRITE,0,0,CREATE_ALWAYS,\
			  FILE_ATTRIBUTE_NORMAL,0
	cmp eax,-1
	jz .error

	mov ebx,eax
	invoke SetFilePointer,eax,0,0,FILE_BEGIN

	lea eax,[dwTemp]
	invoke WriteFile,ebx,[lpHeaderStr],[HeaderStrLen],eax,0
	test eax,eax
	jz .errorclose

	invoke CloseHandle,ebx

ret

.errorclose:

	invoke CloseHandle,ebx

.error:

	or [DLLLoadSuccessBool],1

ret
endp

;==========================================================
proc WriteLogFileInitAttempt uses eax ecx edx ebx, dwErrorLevel, lpMsgStr
;==========================================================
; dwErrorLevel = 0-SUCCESS, 1-FAIL, 2-N/A, 3-NOT IMPLEMENTED

   local dwTemp:DWORD

	cmp [lpMsgStr],0
	jz .exit
	cmp [dwErrorLevel],3
	ja .exit

	invoke CreateFile,atxlogfilepath_const,GENERIC_WRITE,0,0,OPEN_ALWAYS,\
			  FILE_ATTRIBUTE_NORMAL,0
	cmp eax,-1
	jz .error

	mov ebx,eax

	invoke SetFilePointer,eax,0,0,FILE_END

	mov edx,[lpMsgStr]
	mov ecx,edx
	FINDSTRINGEND ecx
	sub ecx,edx

	lea eax,[dwTemp]
	invoke WriteFile,ebx,edx,ecx,eax,0
	test eax,eax
	jz .errorclose

	mov eax,[dwErrorLevel]
	mov edx,[LogMsgPtrTable+4*eax]
	mov ecx,[LogMsgSizeTable+4*eax]

	lea eax,[dwTemp]
	invoke WriteFile,ebx,edx,ecx,eax,0
	test eax,eax
	jz .errorclose

	invoke CloseHandle,ebx

.exit:
ret

.errorclose:

	invoke CloseHandle,ebx

.error:

	or [DLLLoadSuccessBool],1

ret
endp

;============================================================
ATXPROC WriteATXInGameError		; param1 = error string , param2 = address
;============================================================
push ebp
mov ebp,esp
sub esp,200
push eax
push ecx
push edx
push ebx
push edi

	inc [RTErrorCount]
	invoke GetTickCount
	mov [LastErrorTime],eax

	invoke CreateFile,atxlogfilepath_const,GENERIC_WRITE,0,0,OPEN_ALWAYS,\
			  FILE_ATTRIBUTE_NORMAL,0
	cmp eax,INVALID_HANDLE_VALUE
	    jz .exit
	mov ebx,eax

	invoke SetFilePointer,ebx,0,0,FILE_END

	lea edx,[ebp-200]
	cinvoke wsprintf,edx,INGAME_ERROR_DISPLAY_STR,[RTErrorCount],[param1],[param2]

	lea ecx,[ebp-4]
	lea edx,[ebp-200]
	invoke WriteFile,ebx,edx,eax,ecx,0

	invoke CloseHandle,ebx

.exit:
pop edi
pop ebx
pop edx
pop ecx
pop eax
mov esp,ebp
pop ebp
ret 8

;============================================================
ATXPROC WriteLogFileInGame		; param1 = string to print, param2 = string size
;============================================================
push ebp
mov ebp,esp
sub esp,4
push eax
push ecx
push edx
push ebx

	invoke CreateFile,atxlogfilepath_const,GENERIC_WRITE,0,0,OPEN_ALWAYS,\
			  FILE_ATTRIBUTE_NORMAL,0
	cmp eax,INVALID_HANDLE_VALUE
	    jz .exit
	mov ebx,eax

	invoke SetFilePointer,ebx,0,0,FILE_END

	lea ecx,[ebp-4]
	invoke WriteFile,ebx,[param1],[param2],ecx,0

	invoke CloseHandle,ebx

.exit:
pop ebx
pop edx
pop ecx
pop eax
mov esp,ebp
pop ebp
ret 8
