;=========================================================
ATXINITPROC write_exe_proc		; writes to exe (in memory; does not modify exe file)
;=========================================================
; edx = destination addr
; ecx = source addr
; esi = number of bytes to write
; eax = addr of var to check for use or not (0 if none)
;       (if [var] is null, no write is performed)
; edi = log file message pointer

	push edi				; used by "call WriteLogFile"

	test edx,edx
	mov edi,3
	jz .noexeaddress

	test eax,eax
	mov edi,2
	jz .novarcheck

		cmp DWORD [eax],0
		jz .varnullnowriteexe

	.novarcheck:

	push 0
	invoke WriteProcessMemory,ebx,edx,ecx,esi,esp
	pop ecx
	xor edi,edi

	test eax,eax
	jnz @f

		or edi,1

	@@:

	cmp ecx,esi
	jz @f

		or edi,1

	@@:

	or [DLLLoadSuccessBool],edi

	.varnullnowriteexe:
	.noexeaddress:

	push edi
	call WriteLogFileInitAttempt		; param 2 already pushed

ret


;=========================================================
proc EXEWriteRDataDWORDInGame uses edi, lpAddr, ddVal
;=========================================================
; returns 0 if unable to write

   local TempVProtectRData:DWORD

	cmp [lpAddr],0
	jz .unabletomod


	invoke GetCurrentProcessId

	invoke OpenProcess,PROCESS_VM_WRITE+PROCESS_VM_OPERATION,0,eax
	test eax,eax
	     jz .unabletomod

	mov edi,eax

; unprotect ".rdata" section

	mov ecx,[DATASEC_STARTADDR]
	mov edx,[RDATA_START_ADDR]
	sub ecx,edx
	lea eax,[TempVProtectRData]

	invoke VirtualProtectEx,edi,edx,ecx,PAGE_READWRITE,eax
	test eax,eax
	     jz .unabletomod

	mov edx,[lpAddr]
	mov eax,[ddVal]
	mov [edx],eax

; re-protect ".rdata" section

	mov ecx,[DATASEC_STARTADDR]
	mov edx,[RDATA_START_ADDR]
	sub ecx,edx
	lea eax,[TempVProtectRData]

	invoke VirtualProtectEx,edi,edx,ecx,[eax],eax

	mov eax,TRUE

ret

.unabletomod:

       xor eax,eax

ret
endp


