;========================================================
ATXPROC ScreenTextDumperBeginRecording
;========================================================

	mov ecx,ScreenTextList
	call SimpleListReset

	mov [ScreenDumperRunning],TRUE
ret


;========================================================
ATXPROC ScreenTextDumperAddString
;========================================================
; edx = string to add
; eax = length of string

	mov ecx,ScreenTextList
	stdcall SimpleListAppend,edx,eax,2	; add padding for carriage return

ret

;========================================================
ATXPROC ScreenTextDumperEndRecording
;========================================================

	mov [ScreenDumperRunning],FALSE

	cmp [ScreenDumperDoDumpOnNextRun],0
	jz .nodump

		call ScreenTextDump
		mov [ScreenDumperDoDumpOnNextRun],0

	.nodump:
ret


;========================================================
ATXPROC ScreenTextDump
;========================================================
push esi
push edi

	xor edi,edi

	stdcall WriteLogFileInGame,SCREENDUMPER_LOG_HEADER,SCREENDUMPER_LOG_HEADER.size


	SIMPLELISTMAKEITERATOR esi,ScreenTextList

	.dumploop:
	SIMPLELISTITGETDATA esi,.outoftext
	SIMPLELISTITGETDATASIZE esi
	    ; eax = pointer to string (null-terminated)
	    ; ecx = data size

		mov WORD [eax+ecx-2],0A0Dh	; add carriage return (only formatting necessary)

		stdcall WriteLogFileInGame,eax,ecx

	SIMPLELISTITADVANCE esi
	jmp .dumploop

	.outoftext:

	stdcall WriteLogFileInGame,SCREENDUMPER_LOG_FOOTER,SCREENDUMPER_LOG_FOOTER.size

pop edi
pop esi
ret





