;=======================================================
; Pre-level load function
;=======================================================
; These function are called PRECEDING the main game "level load" call
; They are used before ALL level loads, including restarts
; and savegames. If a breakpoint is placed in one of these, it will typically
; halt loading with the progress bar at 0%.

; DO NOT RELY ON STACK - ALREADY NEAR LIMIT

;=======================================================
INTERCEPTPROC PRELEVELLOADINTERCEPT		; eax, ecx, edx may be destroyed
;=======================================================
; (called AFTER FastLoadInterceptProc)

;----------------------------
; RESET FOG COLOR SET ONCE BOOL (FOR NIGHT MODE, IN CASE COLOR HAS NOT BEEN SET PROPERLY)
;----------------------------

	mov [AT05FogWithColorModRunOnceInLevel],FALSE

;----------------------------
; GET CPARTICLES NAMES IDS USING EXE FUNCTION
;----------------------------

	call CParticlesInitTypeIDTable

;----------------------------
; RESET AT109 DEFAULT COLOR CHANGE BUFFER
;----------------------------

	call CParticlesResetAT109Buffer

;----------------------------
; RESET CPARTICLES COLOR SPAN (FOR NIGHT MODE)
;----------------------------

	call CParticlesResetMaxColorsBuffer

	cmp [NIGHTEnabled],FALSE
	jz @f

		mov eax,[NIGHTCParticlesColorMax]
		mov edx,[NIGHTCParticlesTypes]
		call CParticlesSetUniMaskSelective

	@@:

;----------------------------
; SET 2D MAP NOT YET LOADED BOOL
;----------------------------

	mov [MapLoadSuccess],FALSE

;----------------------------
; RELEASE CURRENT NEW HINT STRING (IF EXISTS)
;----------------------------

	LOCALRELEASE [HintNewMessageAddr]

;----------------------------
; SET ORIGINAL GAME SPEED (IN CASE MODIFIED BY LEVEL VIA AT101 OR BY MXT)
;----------------------------

	mov eax,[OrigNormalGameSpeed]
	mov edx,[GAME_SPEED_VAR_ADDR]
	mov [NormalGameSpeed],eax

	cmp [BIONICWOMANEnabled],1
	jnz @f

		mov eax,[DefaultSlowSpeed]

	@@:

	mov [edx],eax
	mov [MXTStateEnabled],0

;----------------------------
; SET DEFAULT HINT STRING (IN CASE NONE LOADED)
;----------------------------

	mov eax,[CURRENT_HINT_ID_ADDR]
	mov [eax],DWORD DEFAULT_HINT_ID

;----------------------------
; RESET AT110 INSTANCE COUNT IF NEW GRF AND ALWAYS RELEASE BUFFERS (will be recreated)
;----------------------------

	cmp [NewGRFLoadDetected],FALSE
	jz @f

		mov [FixSNumberOfAT110Instances],0

	@@:

	call ReleaseFIXOBJECTSPEEDmainbuffer

;----------------------------
; RESET AT112 INPUT TOGGLING TYPE (MAY BE CHANGED BY SAVEGAME LOAD OR AT112)
;----------------------------

	mov [at112inputtogglerid],-1

;----------------------------
; RESET AT113 POSSIBLE SAVEGAME LOAD VALUE
;----------------------------

	mov [AT113SaveGameAITypeUsed],FALSE

;----------------------------
; RELEASE CBACKDROP BUFFER IF NEW GRF LOAD
;----------------------------

	cmp [NewGRFLoadDetected],FALSE
	jz @f

		call CBACKDROPBUFFERRELEASE

	@@:

;----------------------------
; INIT LEVEL TPAs IF NEW GRF LOAD
;----------------------------

	cmp [NewGRFLoadDetected],FALSE
	jz @f

		call TPAFreeCurrentLevelAlternates
		call TPAInitCurrentLevelAlternates

	@@:

;----------------------------
; RESET AT118 REFERENCE BUFFER
;----------------------------

	cmp [NewGRFLoadDetected],FALSE
	jz @f

		LOCALRELEASE [AT118InstanceRefBuf]
		mov [AT118BufDesc.InstanceCount],0
		mov [AT118BufDesc.InstRefBufCut],0
		mov [AT118EnableFastLoadNoSave],FALSE

	@@:

;----------------------------
; RAIN EFFECT
;----------------------------

	call RainEffectSetDefaultAsCurrent
	mov eax,[CurrentRainEnabledUserVal]
	mov [CurrentRainEnabled],eax

;----------------------------
; PLUGIN CALLBACKS
;----------------------------

	xor eax,eax
	mov al,[NewGRFLoadDetected]
	PLUGINSCBINVOKE PLUGIN_CALLBACKS.PreLevelLoad,eax

;----------------------------

;/* REPLACED CODE
mov ecx, DWORD [esp+00000618h]		; original code was +0614h, but must include return address offset (4 bytes)
;*/
ret

