; C++ type descriptor. Passed to MSVCRT.type_info.name method (returns unmangled name).

; struct TYPE_DESCRIPTOR
;        lpVTable         dd      ?
;        spare            dd      ?
;        name             db      ?               ; (array of char containing mangled name)
;ends

; updated version of above

struct type_info			; MSVCRT.dll structure used for RTTI information (variable-length)
  lpVTable dd ?
  RefCount dd ?
  Reserved db ?
ends	   ; mangled name follows, with a null-termating DWORD (aligned to 4)


; RTTI structures translated from igorsk's tutorial on OpenRCE.org

struct RTTICompleteObjectLocator
  signature	   dd ? 	; always zero ?
  offset	   dd ? 	; offset of this vtable in the complete class
  cdOffset	   dd ? 	; constructor displacement offset
  pTypeDescriptor  dd ? 	; TypeDescriptor of the complete class (pointer to TypeDescriptor struct)
  pClassDescriptor dd ? 	; describes inheritance hierarchy (pointer to RTTIClassHierarchyDescriptor struct)
ends


struct RTTIClassHierarchyDescriptor
  signature	  dd ?		; always zero?
  attributes	  dd ?		; bit 0 set = multiple inheritance, bit 1 set = virtual inheritance
  numBaseClasses  dd ?		; number of classes in pBaseClassArray
  pBaseClassArray dd ?		; (pointer to array of RTTIBaseClassDescriptor struct pointers)
ends


struct PMD
  mdisp dd ?	 ; member displacement
  pdisp dd ?	 ; vbtable displacement (seems to usually be -1 for Trespasser classes)
  vdisp dd ?	 ; displacement inside vbtable
ends

struct RTTIBaseClassDescriptor
  pTypeDescriptor   dd ?	; type descriptor of the class (pointer to TypeDescriptor struct)
  numContainedBases dd ?	; number of nested classes following in the Base Class Array
  where 	    PMD 	; pointer-to-member displacement info (correction: not a pointer)
  attributes	    dd ?	; flags, usually 0
ends


; Helper structures

struct RTTIShallow
  COL RTTICompleteObjectLocator
  CHD RTTIClassHierarchyDescriptor
  BCD RTTIBaseClassDescriptor
ends




; DUMPS FROM DEMO 1.1 EXE

; constructs type_info class
; * Reference To: MSVCRT.?name@type_info@@QBEPBDXZ, Ord:0029h
; Names in TRESPASS, item 646
;  Address=0064C354
;  Section=.rdata
;  Type=Import
;  Name=MSVCRT.type_info::name

; demangles name
; * Reference To: MSVCRT.??1type_info@@UAE@XZ, Ord:000Eh
; Names in TRESPASS, item 647
;  Address=0064C274
;  Section=.rdata
;  Type=Import
;  Name=MSVCRT.type_info::~type_info


; mov eax,[LocationAddr]
; mov edx,[eax]
; mov eax,[edx+34h]
; [eax+0] = sub-pointer for start of tree structure
; [eax+4] = number of instances in tree structure
; mov edx,[eax]
; [edx+4] = root node
; [edx+8] = left-most node (lowest InstanceID value)
; [edx+12] = right-most node (highest InstanceID value)
; in node, if NextLeftNode=NextRightNode, we have
; a leaf, if one points to a node with both equal,
; we've reached a left-right end

struct TRES_TREE_NODE
       Unknown			dd	?
       PreviousNode		dd	?
       NextLeftNode		dd	?
       NextRightNode		dd	?
       InstanceID		dd	?
       InstanceAddress		dd	?
ends


struct OBJ_LOC_ORIENT				; (standard location-orientation Tres format)
       Xpos			dd	?
       Ypos			dd	?
       Zpos			dd	?
       Wquat			dd	?
       Xquat			dd	?
       Yquat			dd	?
       Zquat			dd	?
ends
