;==========================================================
; ATX 3DNOW/SSE OPTIMIZATION INITIALIZATION
;==========================================================
InitializeOptProcs:

	mov eax,[UseATX3DNowOpts]
	mov ecx,[UseATXSSEOpts]
	mov edx,eax

	or edx,ecx
	   jz .noatxoptprocs


; both SSE and 3DNow can be enabled, but in this case, SSE functions
; have priority and 3DNow is only used if SSE function is absent

	test ecx,ecx
	     jz .nosse

	mov edx,OPTATXPROCENTRY.SSEProc
	test eax,eax
	mov ecx,edx
	     jz .exitinstcheck

		mov ecx,OPTATXPROCENTRY.AMD3DNowProc

	jmp .exitinstcheck

	.nosse:

	mov edx,OPTATXPROCENTRY.AMD3DNowProc
	mov ecx,edx

	.exitinstcheck:

; edx = offset to preferred function type
; ecx = offset to alternative function type (equal to above if only one enabled)

	push edi
	mov edi,PTRPROCTABLESTART

	.procreplaceloop:

	mov eax,[edi+edx]
	test eax,eax
	     jz .checkalternativefunction

		mov [edi+OPTATXPROCENTRY.STDProc],eax

	jmp .procset

	.checkalternativefunction:
	mov eax,[edi+ecx]
	test eax,eax
	     jz .procset

		mov [edi+OPTATXPROCENTRY.STDProc],eax

	.procset:

	add edi,sizeof.OPTATXPROCENTRY
	cmp edi,(PTRPROCTABLEEND)
	    jb .procreplaceloop

	pop edi

; write special replacement optimization functions to EXE itself

	cmp [UseATX3DNowOpts],0
	    jz .no3dnowspecial

		mov edx,[CONVERT_TO_FACING_PROC]
		mov ecx,CONVERTTOFACINGPROCINTERCEPT_JUMP
		mov eax,(CONVERT_TO_FACING_PROC_3DNOW-5)
		mov esi,5
		sub eax,edx
		mov edi,_message36
		mov [ecx+1],eax 					; calculate jump destination address
		xor eax,eax
		call write_exe_proc					; replace with new member

		mov edx,[QuatMulGameProc]
		mov ecx,QuaternionMul_3DNOW_GAMEVERSION
		mov esi,(QuaternionMul_3DNOW_GAMEVERSION_END-QuaternionMul_3DNOW_GAMEVERSION)
		xor edi,edi
		mov eax,UseOptimizedQuaternionMulProc
		call write_exe_proc

		.no3dnowspecial:

	       ; cmp [UseATXSSEOpts],0
	       ;     jz .nossespecial
	       ;
	       ;         mov edx,[ObjVectorDispProc]
	       ;         mov ecx,ObjVectorDisplace_SSE
	       ;         mov esi,(ObjVectorDisplace_SSE_END-ObjVectorDisplace_SSE)
	       ;         xor edi,edi
	       ;         mov eax,UseOptimizedSSETresProcs
	       ;         call write_exe_proc
	       ;
	       ; .nossespecial:

	.noatxoptprocs:




