;=========================================================
ATXPROC DDrawEnumPrintResolution
;=========================================================
; param1 = width, param2 = height, param3 = colors,
; param4 = refresh rate, param5 = BYTE boolean (print header?)

push ebp
mov ebp,esp
sub esp,4
push ebx

	invoke CreateFile,atxlogfilepath_const,GENERIC_WRITE,0,0,OPEN_ALWAYS,FILE_ATTRIBUTE_NORMAL,0
	cmp eax,-1
	mov ebx,eax
	    jz .exit

	invoke SetFilePointer,ebx,0,0,FILE_END

	cmp BYTE [param5],0			; res count (if null, write header
	    jz .noprintheader
	    lea edx,[ebp-4]
	    invoke WriteFile,ebx,DDRAWENUM_OUTPUT_HEADER_STR,DDRAWENUM_OUTPUT_HEADER_STR.size,edx,0
	.noprintheader:

	cinvoke wsprintf,stack_ext_buffer,DDRAWENUM_OUTPUT_RES_STR,[param1],[param2],[param3],[param4]

	lea edx,[ebp-4]
	invoke WriteFile,ebx,stack_ext_buffer,eax,edx,0

	invoke CloseHandle,ebx

.exit:
pop ebx
mov esp,ebp
pop ebp
ret 20

;=========================================================
ATXPROC DDrawEnumCopyResolutions	; edx = destination structure (assumed empty)
;=========================================================
; returns number of copied resolutions in eax

push esi
push edi

	mov esi,ForcedResolutionsBuffer
	xor eax,eax
	.copyresloop:
	mov ecx,[esi]
	mov edi,[esi+4]
	test ecx,ecx
	     jz .nores
	test edi,edi
	     jz .nores
	     mov [edx],ecx
	     mov [edx+4],edi			; third member is either bpp or refresh rate, and is already predetermined
	     inc eax
	.nores:

	add esi,8
	add edx,12
	cmp esi,ForcedResolutionsBuffer_END
	    jb .copyresloop

pop edi
pop esi
ret
