;============================================================
; TPA INTERCEPT
;============================================================

;============================================================
; MENU.TPA
;============================================================

;============================================================
INTERCEPTPROC ALTERNATEMENUTPAINTERCEPT
;============================================================
; ecx. obj param

push eax

	push esi
	push edi
	mov esi,AlternateMenuTPAFileName
	lea edi,[esp+10h+16]
	call TransferString
	pop edi
	pop esi

pop ecx
pop eax 							; return address
lea edx,[esp+10h]
push 0
push edx
jmp eax

;============================================================
; ALTERNATE/SUBSTITUTE AMBIENT, EFFECTS, STREAM TPAS
;============================================================

; MUST SET PRELEVELLOAD TO NOT RELOAD TPAS IF "Disable Fast Restart" is checked (? - using scn names?)

;============================================================
ATXPROC TPAInitCurrentLevelAlternates
;============================================================
cmp [LVLAltTPAsDisable],0
    jnz .exit

push esi
push edi
push ebx

   ; get MAPS\LVL\levelname.ini filename+path

	mov edi,[mapsdirpathlength]
	add edi,mapsdirpath
	mov DWORD [edi],'LVL\'
	add edi,4

	push edi
	mov esi,mapsdirpath
	mov ecx,edi
	sub ecx,esi
	mov edi,stack_ext_buffer				; copy path
	rep movsb
	mov ebx,edi						; save dest. for tpa names
	pop edi
								; edi = dest. for level name string
	mov esi,[LEVELNAME_OBJ]
	call TransferString
	mov DWORD [edi-4],'.ini'				; replace '.scn' with '.ini'

   ; attempt to load alternate ambient.tpa

	stdcall TPAInitCurrentAlternate,mapsdirpath,stack_ext_buffer,ebx,\
					LVLALT_INI_SECTION_ADDTPA,LVLALT_INI_KEY_AMBIENT,\
					LVLALT_TPA_HANDLECOUNT_AMBIENT,(stack_ext_buffer+1024)
	mov [LVLAltAmbientTPADescStruct],eax

   ; attempt to load alternate effects.tpa

	stdcall TPAInitCurrentAlternate,mapsdirpath,stack_ext_buffer,ebx,\
					LVLALT_INI_SECTION_ADDTPA,LVLALT_INI_KEY_EFFECTS,\
					LVLALT_TPA_HANDLECOUNT_EFFECTS,(stack_ext_buffer+1024)
	mov [LVLAltEffectsTPADescStruct],eax

   ; attempt to load alternate stream.tpa

	stdcall TPAInitCurrentAlternate,mapsdirpath,stack_ext_buffer,ebx,\
					LVLALT_INI_SECTION_ADDTPA,LVLALT_INI_KEY_STREAM,\
					LVLALT_TPA_HANDLECOUNT_STREAM,(stack_ext_buffer+1024)
	mov [LVLAltStreamTPADescStruct],eax

pop ebx
pop edi
pop esi
.exit:
ret

;============================================================
ATXPROC TPAInitCurrentAlternate
;============================================================
; returns eax = NULL if file does not exist, eax = struct otherwise
; requires:
; param1 = INI name+path (null-terminated)
; param2 = base LVL folder path
; param3 = dest. for filepart within base LVL folder path
; param4 = section name
; param5 = key name
; param6 = number of file handles to register
; param7 = space for unprocessed string as read directly from INI

; destroyed: eax,ecx,edx

push ebp
mov ebp,esp
push esi
push edi

	invoke GetPrivateProfileString,[param4],[param5],ZERO_STRING,[param7],MAX_PATH,[param1]
	mov esi,[param7]
	cmp WORD [esi],0030h					; (ZERO_STRING value)
	    jz .fail
	cmp BYTE [esi],0
	    jz	.fail
	cmp BYTE [esi],'\'
	    jnz @f
	    inc esi
	@@:

   ; append filepart to path

	mov edi,[param3]
	call TransferString

   ; check if file exists

	invoke CreateFile,[param2],GENERIC_READ,FILE_SHARE_READ,0,OPEN_EXISTING,\
	       FILE_FLAG_SEQUENTIAL_SCAN,0
	cmp eax,INVALID_HANDLE_VALUE
	    jz .fail
	invoke CloseHandle,eax

	push TPA_BASE_STRUCT_SIZE
	call [YAPAXI]
	add esp,4
	test eax,eax
	     jz .fail

	mov ecx,eax
	stdcall [TPAStructLoadInitProc],[param2],[param6]	; returns struct in eax

pop edi
pop esi
mov esp,ebp
pop ebp
ret (4*7)

.fail:
	xor eax,eax
pop edi
pop esi
mov esp,ebp
pop ebp
ret (4*7)

;============================================================
ATXPROC TPAFreeCurrentLevelAlternates
;============================================================
cmp [LVLAltTPAsDisable],0
    jnz .exit

	FREETPASTRUCT [LVLAltAmbientTPADescStruct]
	FREETPASTRUCT [LVLAltEffectsTPADescStruct]
	FREETPASTRUCT [LVLAltStreamTPADescStruct]

.exit:
ret

;============================================================
INTERCEPTPROC ALTERNATELEVELTPASSOUNDPLAYINTERCEPT
;============================================================
; this intercepts the main sound-play creation proc for the game

; code replaced (all EXEs):
; mov ecx,[esp+8]                                               ; (without stack adjust for call)
; push ecx
; push eax
; call xxxxxxxx                                                 ; (direct call - 5 bytes)

; must return eax = struct for sound from either file or null if in neither

    ; pop return address

	pop edx

    ; fetch param passed to proc

	mov ecx,[esp+8]
	mov [LVLAltTempVar],edx

    ; push params for proc call in advance

	push ecx						; sound ID
	push eax						; TPA struct

    ; compare eax = 3 standard structs
    ; NOTE: depending on caller, eax may already have been intercepted
    ; and represent an alt TPA struct, must continue as usual in this case

	mov edx,[AudioDaemonObjAddr]
	mov edx,[edx]

	cmp [LVLAltEffectsTPADescStruct],0
	    jz @f

	cmp eax,[edx+CAudioDaemon.lpTPAStructEffects]
	    jnz @f
	    mov ecx,[LVLAltEffectsTPADescStruct]
	    mov eax,[esp+4]					; sound ID
	    call IsSoundInTPA
	    test eax,eax
		 jz .loadfromstdtpa
	    mov eax,[LVLAltEffectsTPADescStruct]
	    mov [esp],eax					; new struct
	    jmp .loadfromstdtpa
	@@:

	cmp [LVLAltAmbientTPADescStruct],0
	    jz @f

	cmp eax,[edx+CAudioDaemon.lpTPAStructAmbient]
	    jnz @f
	    mov ecx,[LVLAltAmbientTPADescStruct]
	    mov eax,[esp+4]					; sound ID
	    call IsSoundInTPA
	    test eax,eax
		 jz .loadfromstdtpa
	    mov eax,[LVLAltAmbientTPADescStruct]
	    mov [esp],eax					; new struct
	    jmp .loadfromstdtpa
	@@:

	cmp [LVLAltStreamTPADescStruct],0
	    jz .loadfromstdtpa

	cmp eax,[edx+CAudioDaemon.lpTPAStructStream]
	    jnz .loadfromstdtpa
	    mov ecx,[LVLAltStreamTPADescStruct]
	    mov eax,[esp+4]					; sound ID
	    call IsSoundInTPA
	    test eax,eax
		 jz .loadfromstdtpa
	    mov eax,[LVLAltStreamTPADescStruct]
	    mov [esp],eax					; new struct

.loadfromstdtpa:

    ; params already pushed and modified if necessary

	call [TPALoadSoundSubProc]				; (params are popped later, by game proc)

jmp [LVLAltTempVar]

;============================================================
INTERCEPTPROC STANDARDTPASUNINITPROCINTERCEPT
;============================================================
; called upon game exit

push ecx

	call TPAFreeCurrentLevelAlternates

pop ecx

; REPLACED CODE /*
xor ebx,ebx
mov edi,[esi+0C4h]						; (effects.tpa struct)
; */

ret


;============================================================
INTERCEPTPROC EFFECTSTPASOUNDEXISTCHECKINTERCEPT
;============================================================
; this intercepts are pre-sound existence check used by some
; sound creations (i.e., dino sounds). It is trivial as it is
; done by the main sound proc as well, but the game uses this,
; presumably to skip over other code if no sound is found.
; it checks whether the specified sound is in the TPA (here,
; we must check the alternate TPA as well).

; replaced code: mov ebp,[eax+0C4h]                             ; eax = CAudioDaemon
; no need to pop return address

; must preserve: ebp,eax

	mov ebp,[eax+0C4h]					; REPLACED CODE

	cmp [LVLAltEffectsTPADescStruct],0			; no alternate for level?
	    jnz @f
	ret
	@@:

	test ebp,ebp						; no original effects.tpa?
	     jnz @f
	ret
	@@:

; run rest of procedure (re-called at a different entry point)
; for alternate TPA

; recreate procedure state at entry offset 23

	mov ecx,esp
	mov edx,[EffectsTPACheckSoundProc]

	push DWORD [ecx+24]					; re-push both params
	push DWORD [ecx+20]
	push .retaddrtemp					; return address for simulated call
	sub esp,8						; local vars
	push ebp						; ebp save (trivial)

; (eax still holds CAudioDaemon)

	add edx,23
	mov ebp,[LVLAltEffectsTPADescStruct]

	jmp edx 						; jump to [EffectsTPACheckSoundProc]+23
								; (right after test for null Effects TPA struct)

.retaddrtemp:

	add esp,8						; remove re-pushed params from stack
	test al,al						; was it in alternate effects.tpa?
	     jnz .foundinalternate

	mov eax,[AudioDaemonObjAddr]				; if not, re-instate value in eax and continue
	mov eax,[eax]
								; (ebp was popped by simulated call, re-instated implicitly)
ret

.foundinalternate:						; exit two procedures at once if found

	mov ebp,[esp+4] 					; (pop ebp)
	add esp,16						; (return address+pop ebp+add esp,8) on stack
	mov al,01						; return TRUE

ret								; return to game

; (simulates calling the procedure on the alternate effects.tpa only)

;============================================================
INTERCEPTPROC RESETTPASFOLEYTABLEINTERCEPT
;============================================================
; called upon level start (near end of load), don't know if necessary. attacks
; the tpa struct's foley table arrangement, usually only for effects.tpa because
; the others don't have foley tables (used for collisions with SoundMaterials)

	mov ecx,[LVLAltAmbientTPADescStruct]
	test ecx,ecx
	     jz @f
	call [ResetTPAFoleyTableProc]
	@@:

	mov ecx,[LVLAltEffectsTPADescStruct]
	test ecx,ecx
	     jz @f
	call [ResetTPAFoleyTableProc]
	@@:

	mov ecx,[LVLAltStreamTPADescStruct]
	test ecx,ecx
	     jz @f
	call [ResetTPAFoleyTableProc]
	@@:


mov ecx,[edi+0C4h]						; REPLACED CODE
ret







