;===============================================================
; KEY INTERCEPTION/HANDLING
;===============================================================
; NOTE: For all general movement keys, the game DOES NOT process
; the WM_KEYDOWN, WM_KEYUP, or WM_CHAR messages.
;
; -> General movement keys are scanned using a call to GetAsyncKeyState,
;  referenced nearest to the end of the executable (005DBCE2 for
;  P6 1.1 exe).
; -> Console/command-line (i.e., saving) keys are processed from
;  the WM_CHAR message.
; -> General system keys (ESC, PrintScreen, F11, etc.) are scanned
;  from the WM_KEYDOWN message.
;===============================================================

;===============================================================
INTERCEPTPROC WM_CHARHANDLERPROC		; WM_CHAR HANDLER
;===============================================================
; WNDPROC params start at [esp+10h]

movsx edx,WORD [esp+1Ch]			; replaced code
mov eax,[esp+18h]				; replaced code (eax=wparam=char)
push eax
push ecx
push edx
sub esp,4

call GetGameWindowState
test eax,GAMESTATE_GAMEWND_ACTIVE
jz EXITKEYHANDLER_PASSIVE

	mov [esp],eax

mov eax,[esp+12]

	TESTKEY [UseToggleNewKeys],ToggleNewKeysProc
	cmp [ToggleNewKeys],0
	    jz .nonewkeys

test DWORD [esp],GAMESTATE_CONSOLE_ENABLED
jnz EXITKEYHANDLER_PASSIVE

mov eax,[esp+12]

	TESTKEY [UseDrawDistSubKey],SubstractFromDrawDistProc
	TESTKEY [UseDrawDistAddKey],AddToDrawDistProc
	TESTKEY [LINSTCycleLeftKey],LINSTCycleLeftKeypressed
	TESTKEY [LINSTCycleRightKey],LINSTCycleRightKeypressed
	TESTKEY [LINSTCyclePreviousKey],LINSTCyclePreviousKeypressed
	TESTKEY [THIRDPKeyAimToggle],THIRDP_ToggleAimKeyCHAR
	TESTKEY [THIRDPKeyAimDotToggle],THIRDP_ToggleAimDotKeyCHAR

   ; new hotkeys loop (does not modify eax unless finds match)

	push esi
	mov esi,CheatHotKeyTableRT

	.newhotkeysloop:
	mov edx,[esi+CheatHotKeyTableEntry.KeyValue]
	test edx,edx
	jz .newhotkeysloopend

	cmp eax,edx
	jz NewHotKeysScan_MatchFound

	add esi,sizeof.CheatHotKeyTableEntry
	jmp .newhotkeysloop

	.newhotkeysloopend:
	pop esi

.nonewkeys:

;===============================================================
EXITKEYHANDLER_PASSIVE:
;===============================================================
	add esp,4
	pop edx
	pop ecx
	pop eax
	ret

;===============================================================
ToggleNewKeysProc:
;===============================================================
	xor [ToggleNewKeys],1
	invoke GetTickCount
	mov [ToggleKeysShowStateTime],eax

; continues into...

;===============================================================
EXITKEYHANDLER:
;===============================================================
	add esp,4
	pop edx
	pop ecx
	pop eax

	add esp,4				; get rid of return address
	pop edi
	xor eax,eax
	pop esi
	ret 10h

;===============================================================
NewHotKeysScan_MatchFound:
	mov eax,[esi+CheatHotKeyTableEntry.CheatIndex]
	mov ecx,[CHEATJUMPINDEX+4*eax]
	pop esi
	call EXECUTECHEATCODE			; simulate cheat call without params
jmp EXITKEYHANDLER_PASSIVE
;===============================================================
SubstractFromDrawDistProc:
	push DWORD -1.000000
	call ModifyDrawDistanceRT
jmp EXITKEYHANDLER_PASSIVE
;===============================================================
AddToDrawDistProc:
	push DWORD 1.000000
	call ModifyDrawDistanceRT
jmp EXITKEYHANDLER_PASSIVE
;===============================================================
ExitATXDRVMode_32434:
	call AT108MAIN
jmp EXITKEYHANDLER_PASSIVE
;===============================================================
THIRDP_ToggleAimKeyCHAR:
	xor [THIRDPKeyAimToggleOn],1
jmp EXITKEYHANDLER_PASSIVE
;===============================================================
THIRDP_ToggleAimDotKeyCHAR:
	xor [THIRDPAIMEnabled],1
jmp EXITKEYHANDLER_PASSIVE









; no longer used in ATX 2.06 (time and states patched into game functions)
;;===============================================================
;INTERCEPTPROC WM_KEYDOWNHANDLERPROC             ; WM_KEYDOWN HANDLER
;;===============================================================
;;this code is used to disable certain keys' disabling and to
;;test if we are in-game, in menu, at console, etc.
;
;mov eax,[esp+1Ch]                               ; REPLACED CODE
;mov edx,[esp+18h]
;
;        cmp edx,VK_ESCAPE
;            jz .keydownESCpress                 ; game menu
;        cmp edx,VK_F1
;            jz .simplemenukeypress              ; hint menu
;        cmp edx,VK_F12
;            jz .simplemenukeypress              ; game controls menu
;
;mov edx,eax                                     ; REPLACED CODE
;ret
;
;;===============================================================
;.keydownESCpress:       ; ESC can affect console
;        JUMPIFNOTGAMEWINDOW @f
;                call StartInGameMenuTimer
;        @@:
;mov edx,eax                                     ; REPLACED CODE
;ret
;;===============================================================
;.simplemenukeypress:    ; keys that do not affect console
;        JUMPIFNOTGAMEPLAY @f
;                call StartInGameMenuTimer
;        @@:
;mov edx,eax                                     ; REPLACED CODE
;ret
;;===============================================================
;

; no longer used in ATX 2.06 (time and states patched into game functions)
;;===============================================================
;INTERCEPTPROC CONSOLE_OPEN_KEYS_PRESSED
;;===============================================================
;; usually follows Keydown_F11_Press
;
;        JUMPIFNOTGAMEWINDOW @f
;               ; xor [IsInConsole_BOOL],1
;        @@:
;
;mov ecx,[esi+38h]                               ; REPLACED CODE
;mov eax,[ecx]                                   ; REPLACED CODE
;call DWORD [eax+28h]                            ; REPLACED CODE
;ret
;===============================================================
