;==========================================================
ATXPROC AT100MAIN
;==========================================================

cmp [BIONICWOMANEnabled],1
jz .hasbeenrunonce
cmp [ecx+CAT100.Flags],AT100_RUN_ONCE_ONLY+AT100_HAS_BEEN_RUN_ONCE
jz .hasbeenrunonce

or [ecx+CAT100.Flags],AT100_HAS_BEEN_RUN_ONCE			; set run once bit (no matter if not used)

push edi
mov edi,ecx

	call MXTGetCurrentTransitionState

	cmp eax,1
	jz .entertransition
	cmp eax,2
	jz .ineffect
	cmp eax,3
	jz .exittransition					; (preserves edx)

; (assume as if effect disabled if none of the above are set)

	mov edx,[edi+CAT100.Interval]
	mov eax,[edi+CAT100.SlowGameSpeed]
	mov [MXTStateInterval],edx
	mov [MXTSlowSpeedCurrent],eax
	fld [NormalGameSpeed]
	fsub [MXTSlowSpeedCurrent]
	fstp [MXTSpeedVariationCurrent]

	invoke GetTickCount
	mov [MXTLastTick],eax
	mov ecx,[edi+CAT100.EnterTransInterval]
	mov eax,[edi+CAT100.ExitTransInterval]
	mov [MXTEnterTransitionInterval],ecx
	mov [MXTExitTransitionInterval],eax
	mov [MXTStateEnabled],1

pop edi

.hasbeenrunonce:
ret

.entertransition:

	mov edx,[edi+CAT100.Interval]
	mov eax,[edi+CAT100.SlowGameSpeed]
	mov [MXTStateInterval],edx
	mov [MXTSlowSpeedCurrent],eax
	fld [NormalGameSpeed]
	fsub [MXTSlowSpeedCurrent]
	fstp [MXTSpeedVariationCurrent]
	mov eax,[edi+CAT100.ExitTransInterval]
	mov [MXTExitTransitionInterval],eax

pop edi
ret

.ineffect:

	mov edx,[edi+CAT100.Interval]
	mov eax,[edi+CAT100.SlowGameSpeed]
	mov [MXTStateInterval],edx
	mov [MXTSlowSpeedCurrent],eax
	fld [NormalGameSpeed]
	fsub [MXTSlowSpeedCurrent]
	fstp [MXTSpeedVariationCurrent]

	invoke GetTickCount
	mov [MXTLastTick],eax
	mov eax,[edi+CAT100.ExitTransInterval]
	mov [MXTEnterTransitionInterval],0			; if in effect, do not do enter transition
	mov [MXTExitTransitionInterval],eax

pop edi
ret

.exittransition:

; edx = time (tick) to last ActionType's end
; Same as new MXT effect start, but changes last tick setting
; to compensate for unfinished previous exit trans effect
; However, this generally only works for ATs where the entry transition
; time is the same as the exit transition time.

	push edx

	mov edx,[edi+CAT100.Interval]
	mov eax,[edi+CAT100.SlowGameSpeed]
	mov [MXTStateInterval],edx
	mov [MXTSlowSpeedCurrent],eax
	fld [NormalGameSpeed]
	fsub [MXTSlowSpeedCurrent]
	fstp [MXTSpeedVariationCurrent]

	invoke GetTickCount

	pop edx

	sub eax,edx
	mov [MXTLastTick],eax
	mov ecx,[edi+CAT100.EnterTransInterval]
	mov eax,[edi+CAT100.ExitTransInterval]
	mov [MXTEnterTransitionInterval],ecx
	mov [MXTExitTransitionInterval],eax

pop edi
ret

;==========================================================
ATXPROC AT100_REINIT
;==========================================================

	mov eax,[ecx+CAT100.InitialFlags]			; reset initial runonce value (upon level restart)
	mov [ecx+CAT100.Flags],eax

mov eax,[esp+4] 						; standard
ret 4


