;============================================================
ATXPROC MXTGetCurrentTransitionState		; returns in eax - will disabled effect if expired
;============================================================
; 0 - MXT disabled
; 1 - Enter transition
; 2 - in-effect
; 3 - Exit transition
; FOR 1,2 and 3, value returned in edx is tick count left between current tick
; and next limit tick (time limit of current transition)

cmp [MXTStateEnabled],0
jz .disabled

	invoke GetTickCount
	mov edx,[MXTLastTick]
	add edx,[MXTEnterTransitionInterval]
	cmp eax,edx
	jb .entertransition

	add edx,[MXTStateInterval]
	cmp eax,edx
	jb .ineffect

	add edx,[MXTExitTransitionInterval]
	cmp eax,edx
	jb .exittransition

	mov [MXTStateEnabled],0

.disabled:

	xor eax,eax

ret

.entertransition:

	sub edx,eax
	mov eax,1

ret

.ineffect:

	sub edx,eax
	mov eax,2

ret

.exittransition:

	sub edx,eax
	mov eax,3

ret
