;==========================================================
ATXPROC AT102MAIN
;==========================================================
; loads entire specified bitmap file into allocated memory and replaces old

push ebp
mov ebp,esp
sub esp,20
push ebx
push edi
push esi

	mov edx,ecx
	mov [ebp-4], DWORD 0
	mov esi,[edx+CAT102.lpBitmapFN]
	test esi,esi
	jz .exit

;  append bitmap name to full path (temporarily)

	mov edi,mapsdirpath
	add edi,[mapsdirpathlength]
	.appendloop:
	mov al,[esi]
	cmp al,'"'						; " character (for compatibility)
	jz .appendloopend
	test al,al
	jz .appendloopend
	mov [edi],al						; transfer/append string
	inc esi
	inc edi
	jmp .appendloop
	.appendloopend:
	mov BYTE [edi],0					; add null-terminator


	mov edi,edx

	invoke CreateFile,mapsdirpath,GENERIC_READ,0,0,OPEN_EXISTING,\
		  FILE_ATTRIBUTE_NORMAL,0
	test eax,eax
	jz .exit
	cmp eax,-1
	jz .exit
	mov [ebp-4],eax

	invoke SetFilePointer,eax,0,0,FILE_BEGIN
	cmp eax,-1
	    jz .exit

	invoke GetFileSize,DWORD [ebp-4],0
	cmp eax,-1
	jz .exit

	mov DWORD [ebp-8],eax
	mov [BUFSIZEMapBitmap],eax

	invoke LocalAlloc,LMEM_FIXED,eax
	test eax,eax
	jz .exit
	mov [ebp-16],eax					; store new address

	lea ecx,[ebp-12]
	invoke ReadFile,[ebp-4],eax,[ebp-8],ecx,0
	test eax,eax
	jz .exitfree
	mov eax,[ebp-12]
	cmp eax,[ebp-8]
	jnz .exitfree

	mov eax,[ebp-8] 					; bitmap size
	mov ecx,[ebp-16]					; bitmap in memory
	cmp [ecx+2],eax 					; is BMP size entry in file same as file size?
	jnz .exitfree

	mov eax,[ebp-16]
	add eax,14						; point to BITMAPINFOHEADER/BITMAPCOREHEADER
	cmp DWORD [eax],12					; is BITMAPCOREHEADER w/16-bit values?
	jz .coreheader
								; if not, is BITMAPINFOHEADER
	mov ecx,[eax+4] 					; and size values are 32-bit
	mov [MAPBitmapWidth],ecx
	mov ecx,[eax+8]
	mov [MAPBitmapHeight],ecx
	jmp .setmapvars

.coreheader:

	xor ecx,ecx
	mov cx,[eax+4]
	mov [MAPBitmapWidth],ecx
	mov cx,[eax+6]
	mov [MAPBitmapHeight],ecx

; calculate scale values and store data

.setmapvars:

	mov eax,[edi+CAT102.XPosCornerUL]
	mov [MAPAnchorXValue],eax					; save values and calculate scales

	fld DWORD [edi+CAT102.XPosCornerLR]
	fsub DWORD [edi+CAT102.XPosCornerUL]
	fild [MAPBitmapWidth]					; convert to integer, put in st0
	fdivp st1,st0						; calculate X scale (float diff./width in pixels)
	fstp [MAPScaleXValue]					; may be negative

	mov eax,[edi+CAT102.YPosCornerUL]
	mov [MAPAnchorYValue],eax

	fld DWORD [edi+CAT102.YPosCornerLR]
	fsub DWORD [edi+CAT102.YPosCornerUL]
	fild [MAPBitmapHeight]					; convert to integer, put in st0
	fdivp st1,st0						; calculate Y scale (float diff./width in pixels)
	fstp [MAPScaleYValue]					; may be negative

	push edi

; copy bitmap name to buffer (for later saving)

	mov esi,[edi+CAT102.lpBitmapFN] 			; put name in esi
	mov edx,CurrentMapBuffer

	.moveloop:
	mov al,[esi]
	cmp al,'"'
	jz .endmoveloop
	test al,al
	jz .endmoveloop
	mov [edx],al
	inc esi
	inc edx
	jmp .moveloop
	.endmoveloop:

	mov BYTE [edx],0

; copy four position values (for later saving)

	lea esi,[edi+CAT102.XPosCornerUL]
	mov edi,CurrentMapValues
	mov ecx,4
	rep movsd

	pop edi

	LOCALRELEASE [MAPCurrentBitmap] 			; unload old map if existing

	mov eax,[ebp-16]
	mov [MAPCurrentBitmap],eax				; store new bitmap address
	jmp .success


.exitfree:

	invoke LocalFree,[ebp-16]

.exit:

	CLOSEHANDLE DWORD [ebp-4]
	xor eax,eax

pop esi
pop edi
pop ebx
mov esp,ebp
pop ebp
ret

.success:

	mov [MapLoadSuccess],TRUE
	invoke CloseHandle,[ebp-4]
	mov eax,TRUE

pop esi
pop edi
pop ebx
mov esp,ebp
pop ebp
ret

