;====================================================================
ATXPROC GetTripletScriptValues
;====================================================================
; Retrieves three consecutively-arranged script values of same type (i.e., X,Y,Z)
;
; param1 = offset for first value
; param2 = group ID value
; param3 = misc. value (unknown)
; param4 = address of a variable that holds group value counter
; param5 = value type
; param6 = pointer for results
; returns non-zero in eax if all three values were successfully found

; value 1

	mov ecx,[esp+16]
	mov edx,[esp+12]
	push DWORD [ecx]
	mov eax,[esp+8]
	mov ecx,[esp+12]
	invoke GetEntryValueProc,eax,ecx,edx
	add esp,16

	test eax,eax
	mov ecx,[esp+20]
	     jz .fail

	cmp DWORD [eax+4],ecx
	    jnz .fail

	mov edx,[eax+28h]
	mov eax,[esp+24]
	mov ecx,[esp+16]
	mov [eax],edx				; store value 1

	inc DWORD [ecx]

; value 2

	mov edx,[esp+12]
	push DWORD [ecx]
	mov eax,[esp+8]
	mov ecx,[esp+12]
	add eax,8
	invoke GetEntryValueProc,eax,ecx,edx
	add esp,16

	test eax,eax
	mov ecx,[esp+20]
	     jz .fail

	cmp DWORD [eax+4],ecx
	    jnz .fail

	mov edx,[eax+28h]
	mov eax,[esp+24]
	mov ecx,[esp+16]
	mov [eax+4],edx 			; store value 2

	inc DWORD [ecx]

; value 3

	mov edx,[esp+12]
	push DWORD [ecx]
	mov eax,[esp+8]
	mov ecx,[esp+12]
	add eax,16
	invoke GetEntryValueProc,eax,ecx,edx
	add esp,16

	test eax,eax
	mov ecx,[esp+20]
	     jz .fail

	cmp DWORD [eax+4],ecx
	    jnz .fail

	mov edx,[eax+28h]
	mov eax,[esp+24]
	mov ecx,[esp+16]
	mov [eax+8],edx 			; store value 2

	inc DWORD [ecx]

	mov eax,TRUE

ret 24

.fail:

      xor eax,eax

ret 24


;====================================================================
ATXPROC NewATWriteAbortMsgToLogFile
;====================================================================

	cinvoke wsprintf,stack_ext_buffer,NEWAT_INITABORTMSG_TEMPLATE,[CurrentATNumber],[NoNewATLastAbortReason]
	stdcall WriteLogFileInGame,stack_ext_buffer,eax

ret

;====================================================================
ATXPROC ReadAxxNameIDArray
;====================================================================
; reads all A00..Axx T-Script strings sequentially until none exists for
; a certain Axx, calculates the ID32 hash for each string and creates
; an ID32 array. Returns the number of ID32 written in the array. Array
; MUST be at least 200*4 bytes long (A00-A199).
;
; input:
; ebx = T-Script index for the first string (A00)
; esi = buffer pointer (buffer must be at least 200*4 bytes long)
; output:
; updated ebx with index of last Axx string tested (must be increased once for next T-Script value)
; eax = number of ID32s copied
; destroyed:
; eax, ecx, edx
; EBP CAN NOT BE USED

push edi

	sub ebx,1
	xor edi,edi

	.getinstancesloop:
	add ebx,1
	lea edx,[TSCRIPT_OFFSETVALUE_A00+ebx*8]

	GETSETVALUERET edx,ebx,TSCRIPT_VALUETYPE_STRING
	test eax,eax
	jz .getinstancesloopend

	GETNAMEID32STD eax
	test eax,eax
	jz .getinstancesloopend

	mov [esi+edi],eax
	add edi,4
	cmp edi,(200*4)
	jb .getinstancesloop

	.getinstancesloopend:

	mov eax,edi
	shr eax,2

pop edi
ret
