; These methods are copied from the EXE's code.

;===================================================================
ATXPROC NewATMainDestructor
;===================================================================
; DEFAULT NEW AT DESTRUCTOR.
; destructor for 'this' instance. In the case of ATX ActionTypes, all instances
; should have no sub-members to free, so only the main instance memory
; is freed if necessary. Main memory is only freed if the "freeMem" bool
; is TRUE.

	test BYTE [esp+4],01
	     jz .nomemfree

		cinvoke free,ecx

	.nomemfree:

ret 4

;===================================================================
ATXPROC NewATIndDestructor
;===================================================================
; calls destructor if 'this' instance is not null

	test ecx,ecx
	     jz .nodest

		mov eax,[ecx+CAction.lpVTable]
		push 1
		call [eax+ICAction.Release]		; ecx = this

	.nodest:

ret

;===================================================================
ATXPROC NewATEmptyProc1
;===================================================================
; does nothing

ret

;===================================================================
ATXPROC NewATMethodX
;===================================================================
; returns a certain float value in st0 (unknown).

	mov eax,[NEWAT_METHODX_FLOAT_ADDR]
	fld DWORD [eax]

ret

;===================================================================
ATXPROC NewATReinitProc
;===================================================================
; DEFAULT NEW AT REINIT PROC.
; returns the passed parameter (unknown).

	mov eax,[esp+4]

ret 4


;===================================================================
ATXPROC NewATEmptyProc2
;===================================================================
; returns the passed parameter (unknown).

	mov eax,[esp+4]

ret 4
