;=================================================================
;MENU MODIFICATION/INTERCEPTION CODE AND GAME DIFFICULTY MOD
;=================================================================

;=================================================================
INTERCEPTPROC SLIDER_METHOD_INTERCEPT		; called for EVERY slider in every menu
;=================================================================
push esi
mov esi,ecx					; save object

	push DWORD [esp+10h]			; pass parameters to true method properly
	push DWORD [esp+10h]
	push DWORD [esp+10h]
	call [SliderMethodTrue] 	; call function that calculates new slider value

mov edx,[esi+0Ch]
push eax

	cmp edx,SLIDER_GAME_DIFFICULY_ID	; GAME DIFFICULTY SLIDER CHECK
	    jz .gamediffslider

	cmp edx,SLIDER_DRAW_DISTANCE_ID 	; DRAW DISTANCE SLIDER CHECK
	    jz .drawdistslider

pop eax
pop esi
ret 0Ch

.gamediffslider:

	xor edx,edx
	mov dl,[esi+30h]			; retrieve new slider value from slider instance
	mov [GameDifficultyValue],edx
	sub esp,100
	lea ecx,[esp]
	cinvoke wsprintf,ecx,UINT_STR,edx
	lea ecx,[esp]
	invoke WritePrivateProfileString,section_general,key_gamediff,ecx,atxconfigpath_const
	add esp,100

pop eax
pop esi
ret 0Ch


.drawdistslider:

	fild DWORD [esi+30h]
	sub esp,4
	fadd [float_15]
	fstp DWORD [esp]
	call ModifyDrawDistanceMENU

pop eax
pop esi
ret 0Ch

;=================================================================
INTERCEPTPROC BUTTON_METHOD_INTERCEPT		; ALSO CHECKS FOR LEVEL RESTART
;=================================================================
; At entry, ecx is button instance (object). Member DWORD [ecx+4] is an object
; which describes the target function. Target function VTable is compared
; to a VTable such as the "Restart Level" VTable (often, the VTable is the same
; for all objects on a same DDF file or page). Button instance can then be
; tested for YES/NO/other buttons via ID at [ecx+0Ch].

	mov eax,[ecx+4]
	test eax,eax
	     jz .none

; test for "Restart Level" YES button

	mov edx,[EXIT_RESTART_VTABLE]
	cmp [eax],edx
	    jnz @f
	cmp DWORD [ecx+0Ch],1000		; YES function = 1000, NO = 1001
	    jnz @f
	or [Restart_Exit_Level_BOOL],1
	@@:

; test for NEWGAME button

	mov edx,[NEWGAME_VTABLE]
	cmp [eax],edx
	    jnz @f
	cmp DWORD [ecx+0Ch],1000
	    jnz @f
	or [Restart_Exit_Level_BOOL],1
	@@:

; test for QUICKLOAD OK button

	mov edx,[QUICKLOADOK_VTABLE]
	cmp [eax],edx
	    jnz @f
	cmp DWORD [ecx+0Ch],1001
	    jnz @f
	or [Restart_Exit_Level_BOOL],1
	@@:

; exit

	.none:

	push DWORD [esp+0Ch]			; pass parameters to true method properly
	push DWORD [esp+0Ch]
	push DWORD [esp+0Ch]
	call [ButtonMethodTrue]

ret 0Ch


;=================================================================
INTERCEPTPROC CHECKBOX_METHOD_INTERCEPT 	; (not specifically currently used - hotspots used instead)
;=================================================================

	jmp [CheckboxMethodTrue]

; during function
; member BYTE [esi+24h] = 3 if un-check is being done
; member BYTE [esi+24h] = 1 if check is being done
; after function (location unknown)
; member BYTE [esi+24h] and BYTE [esi+28h] = 0 if un-checked
; member BYTE [esi+24h] and BYTE [esi+28h] = 2 if checked

;=================================================================
INTERCEPTPROC HOTSPOT_METHOD_INTERCEPT
;=================================================================

mov eax,[ecx+0Ch]
push ecx

	cmp eax,HOTSPOT_MATRIX_ID
	    jz .matrix

	cmp eax,HOTSPOT_JUMP_DINOS_ID
	    jz .jumpdinos

	cmp eax,HOTSPOT_RANDOM_DINOS_ID
	    jz .randomdinos

	cmp eax,HOTSPOT_FAST_RESTART_ID
	    jz .fastrestart

.exit:

pop ecx

	push DWORD [esp+0Ch]			; pass parameters to true method properly
	push DWORD [esp+0Ch]
	push DWORD [esp+0Ch]
	call [HotspotMethodTrue]

ret 0Ch

.matrix:
	DOHOTSPOTCLICK UseMXTOnActBite,section_mxt,key_mxtb,CheckboxMatrixObj
	jmp .exit

.jumpdinos:
	DOHOTSPOTCLICK UseDisableActJumpNew,section_actjumpnew,key_nojump,CheckboxJumpDinosObj
	jmp .exit

.randomdinos:
	DOHOTSPOTCLICK UseRandomInstanceLocations,section_general,key_rand,CheckboxRandomInstancesObj
	jmp .exit

.fastrestart:
	DOHOTSPOTCLICK DisableFastLoad,section_general,key_disablefastload,CheckboxFastRestartObj
	jmp .exit

;=================================================================
INTERCEPTPROC ENDOBJECTLOAD_INTERCEPT		; esi=object -> FOR ALL VISUAL OBJECTS
;=================================================================

pop edx 					; return address
						; must not modify eax
push esi					; REPLACED CODE
mov ecx,edi					; REPLACED CODE
push edx

	cmp DWORD [esi+0Ch],CHECKBOX_MATRIX_ID
	    jnz @f
	mov edx,[UseMXTOnActBite]
	mov [CheckboxMatrixObj],esi
	call CheckboxValueGetProc
	@@:

	cmp DWORD [esi+0Ch],CHECKBOX_JUMP_DINOS_ID
	    jnz @f
	mov edx,[UseDisableActJumpNew]
	mov [CheckboxJumpDinosObj],esi
	call CheckboxValueGetProc
	@@:

	cmp DWORD [esi+0Ch],CHECKBOX_RANDOM_INST_ID
	    jnz @f
	mov edx,[UseRandomInstanceLocations]
	mov [CheckboxRandomInstancesObj],esi
	call CheckboxValueGetProc
	@@:

	cmp DWORD [esi+0Ch],CHECKBOX_FAST_RESTART_ID
	    jnz @f
	mov edx,[DisableFastLoad]
	mov [CheckboxFastRestartObj],esi
	call CheckboxValueGetProc
	@@:

jmp DWORD [eax+70h]				; REPLACED CODE - modified - will return to exe upon RET

;=================================================================
ATXPROC CheckboxValueGetProc
;=================================================================

	add edx,edx				; if value 0, will be 0; if value 1, will be 2
	mov [esi+24h],dl
	mov [esi+28h],dl

ret

;=================================================================
INTERCEPTPROC MAINSCREEN_INTERCEPT		; eax=filename (must be passed to CreateFileA)
;=================================================================
; CALLED FOR MORE THAN ONE SCREENS (MAINSCREEN.ddf, RENDER.ddf)

	pop edx
	mov [MainscreenDDFRetAddr],edx	; save return address

repz movsb					; REPLACED CODE
push eax					; REPLACED CODE (filename for CreateFile)

	cmp [UseNewMenuItems],2
	    jz .nomainscreentest
	COMPSTR [edi-15],[MAINSCREEN_TEMP_FILE_NAMEONLY]
	test eax,eax
	     jnz .mainscreenfound
	.nomainscreentest:

	COMPSTR [edi-11],[RENDER_TEMP_FILE_NAMEONLY]
	test eax,eax
	     jnz .renderfound

.exit:

call ebp					; REPLACED CODE (call [CreateFileA])
mov esi,eax					; REPLACED CODE
jmp [MainscreenDDFRetAddr]


.mainscreenfound:

; convert GameDifficulty value int to ASCII

	mov eax,[GameDifficultyValue]
	cmp eax,5
	    jb @f
	    mov eax,2
	    mov [GameDifficultyValue],eax
	@@:
	mov edx,020202020h
	add al,30h				;convert to ASCII
	or eax,edx
	mov [DefaultGameDiffSliderUnitValue],eax

; get additions mainscreen.ddf file from 'MAPS' folder

	push edi
	mov edi,[mapsdirpathlength]
	push esi
	add edi,mapsdirpath
	mov esi,MAINSCREEN_EXT_SOURCEFILE
	call TransferString
	pop esi
	pop edi

	stdcall OpenReadFullFile,mapsdirpath,8,-1
	test eax,eax
	     jz .exit

	mov [MenuTempMem],eax
	mov [MenuTempFileSize],ecx

; copy original mainscreen.ddf file

	push esi
	push edi
	mov esi,MAINSCREEN_TEMP_FILE_NAMEONLY
	mov edi,[mapsdirpathlength]
	add edi,ddfaltpath
	call TransferString
	pop edi
	pop esi

	mov eax,[esp]
	invoke CopyFile,eax,ddfaltpath,FALSE
	test eax,eax
	     jz .exit

; scan additions file for entries to modify

	push esi
	push edi
	mov edi,[MenuTempFileSize]
	mov esi,[MenuTempMem]
	lea edi,[esi+edi-5]
	jmp .msmodscanloop

	    .msmodscanloopgdif:
		mov eax,[DefaultGameDiffSliderUnitValue]
		mov [esi],eax
		add esi,4
	    jmp .msmodscanloopcontinue

	    .msmodscanloopatxv:
		mov DWORD [esi],ATX_VERSION
		add esi,4
	    jmp .msmodscanloopcontinue

	    .msmodscanloopdcut:
		cmp [EXEID],'DEMO'
		    jz .msmodscanloopend
		add esi,4
	    jmp .msmodscanloopcontinue

	.msmodscanloop:
	mov eax,[esi]
	cmp eax,'GDIF'
	    jz .msmodscanloopgdif
	cmp eax,'ATXV'
	    jz .msmodscanloopatxv
	cmp eax,'DCUT'
	    jz .msmodscanloopdcut
	inc esi
	.msmodscanloopcontinue:
	cmp esi,edi
	    jb .msmodscanloop
	.msmodscanloopend:			; edi = pointer to end of buffer to copy

	mov ecx,esi
	mov eax,[MenuTempMem]
	pop edi
	pop esi

	sub ecx,eax
	stdcall WRITE_DDF_NEW,ddfaltpath,eax,ecx
	push eax
	invoke LocalFree,[MenuTempMem]
	pop eax
	test eax,eax
	     jz .exit

	mov DWORD [esp],ddfaltpath		; final step - replace DDF filename used by EXE in CreateFileA
	jmp .exit


.renderfound:

	mov eax,[DRAW_DISTANCE_VAR_ADDR]	; get current Draw Dist value from EXE for slider
	push DWORD [eax]
	fld DWORD [esp]
	fsub [float_15]
	fistp DWORD [esp]
	pop eax
	cmp eax,0
	    jnl @f
	    xor eax,eax
	@@:
	cmp eax,300
	    jna @f
	    mov eax,300
	@@:					; value will be between 0 and 300 in ASCII, max 4 chars w/null-terminator

	cinvoke wsprintf,DefaultDrawDistSliderUnitValue,UINT_STR,eax

	mov eax,[DefaultDrawDistSliderUnitValue]
	call CheckCharsForNull4
	mov [DefaultDrawDistSliderUnitValue],eax

; get additions render.ddf file from 'MAPS' folder

	push edi
	mov edi,[mapsdirpathlength]
	push esi
	add edi,mapsdirpath
	mov esi,RENDER_EXT_SOURCEFILE
	call TransferString
	pop esi
	pop edi

	stdcall OpenReadFullFile,mapsdirpath,8,-1
	test eax,eax
	     jz .exit

	mov [MenuTempMem],eax
	mov [MenuTempFileSize],ecx

; copy original render.ddf file

	push esi
	push edi
	mov esi,RENDER_TEMP_FILE_NAMEONLY
	mov edi,[mapsdirpathlength]
	add edi,ddfaltpath
	call TransferString
	pop edi
	pop esi

	mov eax,[esp]
	invoke CopyFile,eax,ddfaltpath,FALSE
	test eax,eax
	     jz .exit

; scan for draw distance initial value set

	push esi
	push edi
	mov esi,[MenuTempMem]
	mov edi,[MenuTempFileSize]
	lea edi,[esi+edi-5]
	mov edx,'DDST'
	mov ecx,[DefaultDrawDistSliderUnitValue]

	.ddinitvalueloop:
	cmp DWORD [esi],edx
	    jnz @f
	    mov [esi],ecx
	    add esi,4
	@@:
	inc esi
	cmp esi,edi
	    jb .ddinitvalueloop
	pop edi
	pop esi


	stdcall WRITE_DDF_NEW,ddfaltpath,[MenuTempMem],[MenuTempFileSize]
	push eax
	invoke LocalFree,[MenuTempMem]
	pop eax
	test eax,eax
	     jz .exit

	mov DWORD [esp],ddfaltpath
	jmp .exit

;=================================================================
ATXPROC WRITE_DDF_NEW
;=================================================================
; [ebp+8] = name of file to modify
; [ebp+12] = buffer (to write from)
; [ebp+16] = size of buffer
; returns FALSE if error

push ebp
mov ebp,esp
sub esp,12
mov DWORD [ebp-4],0
mov DWORD [ebp-8],0
mov DWORD [ebp-12],FALSE

	invoke SetFileAttributes,[ebp+8],FILE_ATTRIBUTE_NORMAL
	test eax,eax
	     jz .error

	invoke CreateFile,[ebp+8],GENERIC_WRITE,0,0,\
			  OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0
	cmp eax,-1
	    jz .error
	mov [ebp-4],eax

	invoke SetFilePointer,[ebp-4],0,0,FILE_END
	cmp eax,-1
	    jz .error

	lea ecx,[ebp-8]
	invoke WriteFile,[ebp-4],[ebp+12],[ebp+16],ecx,0
	test eax,eax
	mov ecx,[ebp-8]
	    jz .error
	cmp ecx,[ebp+16]
	    jnz .error

	mov DWORD [ebp-12],TRUE

.error:

	CLOSEHANDLE DWORD [ebp-4]
	mov eax,[ebp-12]

mov esp,ebp
pop ebp
ret 12
