;============================================================
proc RefreshCameraPerspective uses ebx
;============================================================

   local tempARVal:DWORD,tempCamProps:CameraProperties

	xor ebx,ebx	; ebx = non-zero if valid aspect ratio setting in tempARVal

	cmp [UseMatchARWithRes],0
	jz .nomatchres

		; get resolution
		GETBBSURFACEDIMENSIONS eax

		; calc ratio
		fild DWORD [eax]
		fidiv DWORD [eax+4]
		fstp [tempARVal]

	jmp .applyratio

	.nomatchres:

		fld [UseCustomAspectRatio.Val2] 	; must be >= 0
		fcom [float_0]
		fstsw ax
		test ah,FPU_VALUE_BELOW_OR_EQUAL
		jnz .endarcalc

		; calc ratio
		fdivr [UseCustomAspectRatio.Val1]
		fst [tempARVal]

		fcomp [float_0]
		fstsw ax
		test ah,FPU_VALUE_BELOW_OR_EQUAL
		jnz .endarcalc

	.applyratio:

		mov ebx,TRUE

		GETCCAMERAINSTANCE eax

		; Overwrite default monitor aspect (4/3)
		stdcall EXEWriteRDataDWORDInGame,[ASPECTRATIOVARADDR],[tempARVal]

		; Overwrite pseudo-aspect ratio in main CRasterWin instance
		; Note: It uses the whole screen resolution during calculation and NOT the surface size, but we don't have access here, so... ?
		GETMAINCRASTERWININSTANCE eax
		fild [eax+CRasterWin.Width]
		fidiv [eax+CRasterWin.Height]
		fdiv [tempARVal]	; by default, 4/3 = 1.333333
		fstp [eax+CRasterWin.PseudoAspectRatio]

		lea edx,[tempCamProps]
		stdcall GetCameraProperties,edx

		lea edx,[tempCamProps]
		mov eax,[tempARVal]
		mov [edx+CameraProperties.AspectRatio],eax
		stdcall SetCameraProperties,edx

	.endarcalc:


	cmp [UseSyncARFOV],0
	jz .nofovsync
	test ebx,ebx
	jz .nofovsync


		mov eax,[CamReferenceFOV]
		mov ecx,[AT06CameraFOVValue]
		test ecx,ecx
		jz @f
			mov eax,ecx
		@@:

		push eax
		fld DWORD [esp]
		fmul [tempARVal]
		fdiv [CamReferenceAspectMul]
		fstp DWORD [esp]
		call AdjustCameraFOVWidescreen

	jmp .endfovset

	.nofovsync:

		mov eax,[AT06CameraFOVValue]
		test eax,eax
		jz .endfovset

			stdcall AdjustCameraFOVWidescreen,eax

	.endfovset:

ret
endp
