;=======================================================
proc RegisterSpotLight uses ebx esi, lpSpotlightInfo
;=======================================================

   local lpIDirect3DLight:DWORD

	mov ebx,[MAINCDIRECT3DINFOOBJ_ADDR]

	mov ecx,[ebx+CDirect3DInfo.lpIDirect3D3Obj]
	lea edx,[lpIDirect3DLight]
	mov eax,[ecx]
	push 0
	push edx
	push ecx
	call [eax+IDirect3D3.CreateLight]
	cmp eax,D3D_OK
	jnz .error

	mov esi,[lpIDirect3DLight]

	stdcall SetSpotLightParams,esi,[lpSpotlightInfo]

	mov ecx,[ebx+CDirect3DInfo.lpIDirect3DViewport3Obj]
	push esi
	mov eax,[ecx]
	push ecx
	call [eax+IDirect3DViewport3.AddLight]

	mov eax,esi
ret

.error:

	xor eax,eax
ret
endp

;=======================================================
proc UnregisterSpotLight lpLight
;=======================================================

	mov ecx,[ebx+CDirect3DInfo.lpIDirect3DViewport3Obj]
	push [lpLight]
	mov eax,[ecx]
	push ecx
	call [eax+IDirect3DViewport3.DeleteLight]

	mov ecx,[lpLight]
	mov eax,[ecx]
	push ecx
	call [eax+IDirect3DLight.Release]

ret
endp


;=======================================================
proc SetSpotLightParams uses esi, lpLight, lpSpotlightInfo
;=======================================================

    local D3DLight:D3DLIGHT2

	mov esi,[lpSpotlightInfo]
	mov [D3DLight.dwSize],sizeof.D3DLIGHT2
	mov [D3DLight.dltType],D3DLIGHT_DIRECTIONAL		;D3DLIGHT_SPOT         ; 2

	mov eax,[esi+ATXSPOTLIGHTINFO.LightColor.R]
	mov edx,[esi+ATXSPOTLIGHTINFO.LightColor.G]
	mov [D3DLight.dcvColor.r],eax
	mov [D3DLight.dcvColor.g],edx
	mov eax,[esi+ATXSPOTLIGHTINFO.LightColor.B]
	mov edx,[esi+ATXSPOTLIGHTINFO.LightColor.A]
	mov [D3DLight.dcvColor.b],eax
	mov [D3DLight.dcvColor.a],edx

	mov eax,[esi+ATXSPOTLIGHTINFO.Position.X]
	mov ecx,[esi+ATXSPOTLIGHTINFO.Position.Y]
	mov edx,[esi+ATXSPOTLIGHTINFO.Position.Z]
	mov [D3DLight.dvPosition.x],eax
	mov [D3DLight.dvPosition.y],ecx
	mov [D3DLight.dvPosition.z],edx

	mov eax,[esi+ATXSPOTLIGHTINFO.Direction.X]
	mov ecx,[esi+ATXSPOTLIGHTINFO.Direction.Y]
	mov edx,[esi+ATXSPOTLIGHTINFO.Direction.Z]
	mov [D3DLight.dvDirection.x],eax
	mov [D3DLight.dvDirection.y],ecx
	mov [D3DLight.dvDirection.z],edx

	mov eax,[esi+ATXSPOTLIGHTINFO.Range]
	mov edx,[esi+ATXSPOTLIGHTINFO.Falloff]
	mov [D3DLight.dvRange],eax
	mov [D3DLight.dvFalloff],edx

	mov eax,[esi+ATXSPOTLIGHTINFO.Attenuation.A0]
	mov ecx,[esi+ATXSPOTLIGHTINFO.Attenuation.A1]
	mov edx,[esi+ATXSPOTLIGHTINFO.Attenuation.A2]
	mov [D3DLight.dvAttenuation0],eax
	mov [D3DLight.dvAttenuation1],ecx
	mov [D3DLight.dvAttenuation2],edx

	mov eax,[esi+ATXSPOTLIGHTINFO.InnerConeAngle]
	mov ecx,[esi+ATXSPOTLIGHTINFO.OuterConeAngle]
	mov [D3DLight.dvTheta],eax
	mov [D3DLight.dvPhi],ecx

	xor eax,eax
	test [esi+ATXSPOTLIGHTINFO.Flags],ATXSPOTLIGHT_ISENABLED
	jz @f

		or eax,D3DLIGHT_ACTIVE
	@@:
	mov [D3DLight.dwFlags],eax

	SETSPOTLIGHT [lpLight],[D3DLight]

ret
endp


;=======================================================
proc UpdateSpotLightPosDir uses esi edi, lpLight, lpPosition, lpDirection
;=======================================================

    local D3DLight:D3DLIGHT2

	mov [D3DLight.dwSize],sizeof.D3DLIGHT2
	GETSPOTLIGHT [lpLight],[D3DLight]


	mov esi,[lpPosition]
	mov eax,[esi+POSITION.X]
	mov ecx,[esi+POSITION.Y]
	mov edx,[esi+POSITION.Z]
	mov [D3DLight.dvPosition.x],eax
	mov [D3DLight.dvPosition.y],ecx
	mov [D3DLight.dvPosition.z],edx

	mov esi,[lpDirection]
	mov eax,[esi+VECTOR.X]
	mov ecx,[esi+VECTOR.Y]
	mov edx,[esi+VECTOR.Z]
	mov [D3DLight.dvDirection.x],eax
	mov [D3DLight.dvDirection.y],ecx
	mov [D3DLight.dvDirection.z],edx

	SETSPOTLIGHT [lpLight],[D3DLight]

ret
endp

;=======================================================
proc EnableSpotLight lpLight
;=======================================================

    local D3DLight:D3DLIGHT2

	mov [D3DLight.dwSize],sizeof.D3DLIGHT2
	GETSPOTLIGHT [lpLight],[D3DLight]

	or [D3DLight.dwFlags],D3DLIGHT_ACTIVE

	SETSPOTLIGHT [lpLight],[D3DLight]
ret
endp

;=======================================================
proc DisableSpotLight lpLight
;=======================================================

    local D3DLight:D3DLIGHT2

	mov [D3DLight.dwSize],sizeof.D3DLIGHT2
	GETSPOTLIGHT [lpLight],[D3DLight]

	and [D3DLight.dwFlags],NOT D3DLIGHT_ACTIVE

	SETSPOTLIGHT [lpLight],[D3DLight]
ret
endp


;=======================================================
proc ToggleSpotLight lpLight
;=======================================================

    local D3DLight:D3DLIGHT2

	mov [D3DLight.dwSize],sizeof.D3DLIGHT2
	GETSPOTLIGHT [lpLight],[D3DLight]

	xor [D3DLight.dwFlags],NOT D3DLIGHT_ACTIVE

	SETSPOTLIGHT [lpLight],[D3DLight]

ret
endp



