;=========================================================
; Direct3D 7 interfaces (translated from Linux WINE C++ headers)
;=========================================================

interface IDirect3D,\	 
	    QueryInterface,\
	    AddRef,\
	    Release,\
	    Initialize,\
	    EnumDevices,\
	    CreateLight,\
	    CreateMaterial,\
	    CreateViewport,\
	    FindDevice


interface IDirect3D2,\	  
	    QueryInterface,\
	    AddRef,\
	    Release,\
	    EnumDevices,\
	    CreateLight,\
	    CreateMaterial,\
	    CreateViewport,\
	    FindDevice,\
	    CreateDevice

interface IDirect3D3,\	  
	    QueryInterface,\
	    AddRef,\
	    Release,\
	    EnumDevices,\
	    CreateLight,\
	    CreateMaterial,\
	    CreateViewport,\
	    FindDevice,\
	    CreateDevice,\
	    CreateVertexBuffer,\
	    EnumZBufferFormats,\
	    EvictManagedTextures

interface IDirect3D7,\	  
	    QueryInterface,\
	    AddRef,\
	    Release,\
	    EnumDevices,\
	    CreateDevice,\
	    CreateVertexBuffer,\
	    EnumZBufferFormats,\
	    EvictManagedTextures

interface IDirect3DLight,\    
	    QueryInterface,\
	    AddRef,\
	    Release,\
	    Initialize,\
	    SetLight,\
	    GetLight

interface IDirect3DMaterial,\	 
	    QueryInterface,\
	    AddRef,\
	    Release,\
	    Initialize,\
	    SetMaterial,\
	    GetMaterial,\
	    GetHandle,\
	    Reserve,\
	    Unreserve


interface IDirect3DMaterial2,\	  
	    QueryInterface,\
	    AddRef,\
	    Release,\
	    SetMaterial,\
	    GetMaterial,\
	    GetHandle


interface IDirect3DMaterial3,\	  
	    QueryInterface,\
	    AddRef,\
	    Release,\
	    SetMaterial,\
	    GetMaterial,\
	    GetHandle

interface IDirect3DTexture,\	
	    QueryInterface,\
	    AddRef,\
	    Release,\
	    Initialize,\
	    GetHandle,\
	    PaletteChanged,\
	    Load,\
	    Unload


interface IDirect3DTexture2,\	 
	    QueryInterface,\
	    AddRef,\
	    Release,\
	    GetHandle,\
	    PaletteChanged,\
	    Load


interface IDirect3DViewport,\	 
	    QueryInterface,\
	    AddRef,\
	    Release,\
	    Initialize,\
	    GetViewport,\
	    SetViewport,\
	    TransformVertices,\
	    LightElements,\
	    SetBackground,\
	    GetBackground,\
	    SetBackgroundDepth,\
	    GetBackgroundDepth,\
	    Clear,\
	    AddLight,\
	    DeleteLight,\
	    NextLight

interface IDirect3DViewport2,\	  
	    QueryInterface,\
	    AddRef,\
	    Release,\
	    Initialize,\
	    GetViewport,\
	    SetViewport,\
	    TransformVertices,\
	    LightElements,\
	    SetBackground,\
	    GetBackground,\
	    SetBackgroundDepth,\
	    GetBackgroundDepth,\
	    Clear,\
	    AddLight,\
	    DeleteLight,\
	    NextLight,\
	    GetViewport2,\
	    SetViewport2


interface IDirect3DViewport3,\	  
	    QueryInterface,\
	    AddRef,\
	    Release,\
	    Initialize,\
	    GetViewport,\
	    SetViewport,\
	    TransformVertices,\
	    LightElements,\
	    SetBackground,\
	    GetBackground,\
	    SetBackgroundDepth,\
	    GetBackgroundDepth,\
	    Clear,\
	    AddLight,\
	    DeleteLight,\
	    NextLight,\
	    GetViewport2,\
	    SetViewport2,\
	    SetBackgroundDepth2,\
	    GetBackgroundDepth2,\
	    Clear2


interface IDirect3DExecuteBuffer,\    
	    QueryInterface,\
	    AddRef,\
	    Release,\
	    Initialize,\
	    Lock,\
	    Unlock,\
	    SetExecuteData,\
	    GetExecuteData,\
	    Validate,\
	    Optimize

interface IDirect3DDevice,\    
	    QueryInterface,\
	    AddRef,\
	    Release,\
	    Initialize,\
	    GetCaps,\
	    SwapTextureHandles,\
	    CreateExecuteBuffer,\
	    GetStats,\
	    Execute,\
	    AddViewport,\
	    DeleteViewport,\
	    NextViewport,\
	    Pick,\
	    GetPickRecords,\
	    EnumTextureFormats,\
	    CreateMatrix,\
	    SetMatrix,\
	    GetMatrix,\
	    DeleteMatrix,\
	    BeginScene,\
	    EndScene,\
	    GetDirect3D


interface IDirect3DDevice2,\	
	    QueryInterface,\
	    AddRef,\
	    Release,\
	    GetCaps,\
	    SwapTextureHandles,\
	    GetStats,\
	    AddViewport,\
	    DeleteViewport,\
	    NextViewport,\
	    EnumTextureFormats,\
	    BeginScene,\
	    EndScene,\
	    GetDirect3D,\
	    SetCurrentViewport,\
	    GetCurrentViewport,\
	    SetRenderTarget,\
	    GetRenderTarget,\
	    Begin,\
	    BeginIndexed,\
	    Vertex,\
	    Index,\
	    End,\
	    GetRenderState,\
	    SetRenderState,\
	    GetLightState,\
	    SetLightState,\
	    SetTransform,\
	    GetTransform,\
	    MultiplyTransform,\
	    DrawPrimitive,\
	    DrawIndexedPrimitive,\
	    SetClipStatus,\
	    GetClipStatus


interface IDirect3DDevice3,\	
	    QueryInterface,\
	    AddRef,\
	    Release,\
	    GetCaps,\
	    GetStats,\
	    AddViewport,\
	    DeleteViewport,\
	    NextViewport,\
	    EnumTextureFormats,\
	    BeginScene,\
	    EndScene,\
	    GetDirect3D,\
	    SetCurrentViewport,\
	    GetCurrentViewport,\
	    SetRenderTarget,\
	    GetRenderTarget,\
	    Begin,\
	    BeginIndexed,\
	    Vertex,\
	    Index,\
	    End,\
	    GetRenderState,\
	    SetRenderState,\
	    GetLightState,\
	    SetLightState,\
	    SetTransform,\
	    GetTransform,\
	    MultiplyTransform,\
	    DrawPrimitive,\
	    DrawIndexedPrimitive,\
	    SetClipStatus,\
	    GetClipStatus,\
	    DrawPrimitiveStrided,\
	    DrawIndexedPrimitiveStrided,\
	    DrawPrimitiveVB,\
	    DrawIndexedPrimitiveVB,\
	    ComputeSphereVisibility,\
	    GetTexture,\
	    SetTexture,\
	    GetTextureStageState,\
	    SetTextureStageState,\
	    ValidateDevice


interface IDirect3DDevice7,\	
	    QueryInterface,\
	    AddRef,\
	    Release,\
	    GetCaps,\
	    EnumTextureFormats,\
	    BeginScene,\
	    EndScene,\
	    GetDirect3D,\
	    SetRenderTarget,\
	    GetRenderTarget,\
	    Clear,\
	    SetTransform,\
	    GetTransform,\
	    SetViewport,\
	    MultiplyTransform,\
	    GetViewport,\
	    SetMaterial,\
	    GetMaterial,\
	    SetLight,\
	    GetLight,\
	    SetRenderState,\
	    GetRenderState,\
	    BeginStateBlock,\
	    EndStateBlock,\
	    PreLoad,\
	    DrawPrimitive,\
	    DrawIndexedPrimitive,\
	    SetClipStatus,\
	    GetClipStatus,\
	    DrawPrimitiveStrided,\
	    DrawIndexedPrimitiveStrided,\
	    DrawPrimitiveVB,\
	    DrawIndexedPrimitiveVB,\
	    ComputeSphereVisibility,\
	    GetTexture,\
	    SetTexture,\
	    GetTextureStageState,\
	    SetTextureStageState,\
	    ValidateDevice,\
	    ApplyStateBlock,\
	    CaptureStateBlock,\
	    DeleteStateBlock,\
	    CreateStateBlock,\
	    Load,\
	    LightEnable,\
	    GetLightEnable,\
	    SetClipPlane,\
	    GetClipPlane,\
	    GetInfo


interface IDirect3DVertexBuffer,\    
	    QueryInterface,\
	    AddRef,\
	    Release,\
	    Lock,\
	    Unlock,\
	    ProcessVertices,\
	    GetVertexBufferDesc,\
	    Optimize


interface IDirect3DVertexBuffer7,\    
	    QueryInterface,\
	    AddRef,\
	    Release,\
	    Lock,\
	    Unlock,\
	    ProcessVertices,\
	    GetVertexBufferDesc,\
	    Optimize,\
	    ProcessVerticesStrided

