;=========================================================
; DirectDraw structures/values (many thanks to FASM example files)
;=========================================================
; IMPORTANT NOTE: DirectDraw calls involving DDSURFACEDESC-based structures
; must use sizeof.DDSURFACEDESC when using software mode and
; sizeof.DDSURFACEDESC2 when using hardware mode, or will return
; with invalid params error.


struct DDCOLORKEY
  dwColorSpaceLowValue	dd ?
  dwColorSpaceHighValue dd ?
ends

struct DDPIXELFORMAT
  dwSize	    dd ?
  dwFlags	    dd ?
  dwFourCC	    dd ?
 union
  dwRGBBitCount       dd ?
  dwYUVBitCount       dd ?
  dwZBufferBitDepth   dd ?
  dwAlphaBitDepth     dd ?
  dwLuminanceBitCount dd ?
  dwBumpBitCount      dd ?
 ends
 union
  dwRBitMask	      dd ?
  dwYBitMask	      dd ?
  dwStencilBitDepth   dd ?
  dwLuminanceBitMask  dd ?
  dwBumpDuBitMask     dd ?
 ends
 union
  dwGBitMask	      dd ?
  dwUBitMask	      dd ?
  dwZBitMask	      dd ?
  dwBumpDvBitMask     dd ?
 ends
 union
  dwBBitMask		 dd ?
  dwVBitMask		 dd ?
  dwStencilBitMask	 dd ?
  dwBumpLuminanceBitMask dd ?
 ends
 union
  dwRGBAlphaBitMask	  dd ?
  dwYUVAlphaBitMask	  dd ?
  dwLuminanceAlphaBitMask dd ?
  dwRGBZBitMask 	  dd ?
  dwYUVZBitMask 	  dd ?
 ends
ends

struct DDSCAPS
  dwCaps dd ?
ends

struct DDSCAPS2
	dwCaps	dd ?
	dwCaps2 dd ?
	dwCaps3 dd ?
	dwCaps4 dd ?
ends

struct DDSURFACEDESC2
	dwSize		  dd ?
	dwFlags 	  dd ?
	dwHeight	  dd ?
	dwWidth 	  dd ?
  union
	dwLinearSize	  dd ?
	lPitch		  dd ?
  ends
	dwBackBufferCount dd ?
  union
	dwZBufferBitDepth dd ?
	dwRefreshRate	  dd ?
	dwMipMapCount	  dd ?
  ends
	dwAlphaBitDepth   dd ?
	dwReserved	  dd ?
	lpSurface	  dd ?
	ddckCKDestOverlay DDCOLORKEY
	ddckCKDestBlt	  DDCOLORKEY
	ddckCKSrcOverlay  DDCOLORKEY
	ddckCKSrcBlt	  DDCOLORKEY
	ddpfPixelFormat   DDPIXELFORMAT
	ddsCaps 	  DDSCAPS2
	dwTextureStage	  dd ?
ends

struct DDSURFACEDESC
  dwSize	    dd ?
  dwFlags	    dd ?
  dwHeight	    dd ?
  dwWidth	    dd ?
 union
  lPitch	    dd ?
  dwLinearSize	    dd ?
 ends
  dwBackBufferCount dd ?
 union
  dwMipMapCount     dd ?
  dwZBufferBitDepth dd ?
  dwRefreshRate     dd ?
 ends
  dwAlphaBitDepth   dd ?
  dwReserved	    dd ?
  lpSurface	    dd ?
  ddckCKDestOverlay DDCOLORKEY
  ddckCKDestBlt     DDCOLORKEY
  ddckCKSrcOverlay  DDCOLORKEY
  ddckCKSrcBlt	    DDCOLORKEY
  ddpfPixelFormat   DDPIXELFORMAT
  ddsCaps	    DDSCAPS
ends


struct DDBLTFX		      ;(not from example)
	dwSize			 dd	  sizeof.DDBLTFX
	dwDDFX			 dd	  ?
	dwROP			 dd	  ?
	dwDDROP 		 dd	  ?
	dwRotationAngle 	 dd	  ?
	dwZBufferOpCode 	 dd	  ?
	dwZBufferLow		 dd	  ?
	dwZBufferHigh		 dd	  ?
	dwZBufferBaseDest	 dd	  ?
	dwZDestConstBitDepth	 dd	  ?
  union
	dwZDestConst		 dd	  ?
	lpDDSZBufferDest	 dd	  ?
  ends
	dwZSrcConstBitDepth	 dd	  ?
  union
	dwZSrcConst		 dd	  ?
	lpDDSZBufferSrc 	 dd	  ?
  ends

	dwAlphaEdgeBlendBitDepth dd	  ?
	dwAlphaEdgeBlend	 dd	  ?
	dwReserved		 dd	  ?
	dwAlphaDestConstBitDepth dd	  ?
  union
	dwAlphaDestConst	 dd	  ?
	lpDDSAlphaDest		 dd	  ?
  ends
	dwAlphaSrcConstBitDepth  dd	  ?
  union
	dwAlphaSrcConst 	 dd	  ?
	lpDDSAlphaSrc		 dd	  ?
  ends
  union
	dwFillColor		 dd	  ?
	dwFillDepth		 dd	  ?
	dwFillPixel		 dd	  ?
	lpDDSPattern		 dd	  ?
  ends
	ddckDestColorkey	 DDCOLORKEY
	ddckSrcColorkey 	 DDCOLORKEY
ends