;============================================================
ATXPROC SpanResize24BitColor
;============================================================
; [esp+4] = color to convert
; [esp+8] = new color span (maximum color value)
; destroys NO registers except eax (= result)
; NOT OPTIMIZED
; This function will convert a color from a 00FFFFFFh 256-color value component
; to a 00RRGGBBh RR/GG/BB-color value format, where each color component is less or equal to
; 0FFh. If all color components are the same, this will cause the
; color simply to diminish in intensity and keep its original proportionality.
; [esp+8] represents the maximum possible color value.

push ecx
push edx

	mov ecx,[esp+12]
	mov edx,[esp+16]
	call SpanResize8BitColor
	mov eax,ecx

	mov ecx,[esp+12]
	mov edx,[esp+16]
	shr ecx,8
	shr edx,8
	call SpanResize8BitColor
	shl ecx,8
	or eax,ecx

	mov ecx,[esp+12]
	mov edx,[esp+16]
	shr ecx,16
	shr edx,16
	call SpanResize8BitColor
	shl ecx,16
	or eax,ecx

pop edx
pop ecx
ret 8

;============================================================
ATXPROC SpanResize8BitColor		; cl = color to convert, dl = max span -> result in ecx (cl)
;============================================================
; destroyed: ecx, edx

       and ecx,0FFh
       and edx,0FFh
       push ecx
       push edx
       fild DWORD [esp+4]		; cl/255 = new/maxspan -> new = (cl/255)*maxspan)
       fmul [float_1div255]
       fild DWORD [esp]
       fmulp
       fistp DWORD [esp]
       add esp,8
       mov cl,[esp-8]

ret

;============================================================
ATXPROC Convert24BitPixelTo16Bit_565	; esi = pointer to pixel, ax = 16-bit
;============================================================

	mov ax,[esi]
	mov ecx,eax
	mov dh,[esi+2]
	and eax,0F8h
	and ecx,0FC00h
	and edx,0F800h
	shr eax,3
	shr ecx,5
	or eax,ecx
	or eax,edx

ret

;============================================================
ATXPROC Convert24BitPixelTo16Bit_555	; esi = pointer to pixel, ax = 16-bit
;============================================================

	mov ax,[esi]
	mov ecx,eax
	mov dh,[esi+2]
	and eax,0F8h
	and ecx,0F800h
	and edx,0F800h
	shr eax,3
	shr ecx,6
	shr edx,1
	or eax,ecx
	or eax,edx

ret
