; Compile using FASM. Version used for last release: 1.66 (May 7, 2006)

TRES_PLUGIN_VERSION	equ	'1.2'

format PE GUI 4.0 DLL
entry DllEntryPoint

include '%fasminc%\win32a.inc'
include 'Plugin.inc'

;===========================================================
section '.code' code readable executable
;===========================================================

proc DllEntryPoint hinstDLL,fdwReason,lpvReserved
	mov edx,[hinstDLL]
	mov eax,TRUE
	mov [dllhandle],edx
ret
endp

proc ODBG_Plugindata c uses esi edi, shortname
;shortname is 32 bytes
	mov esi,pluginname
	mov edi,[shortname]
	mov ecx,(pluginname_end-pluginname)
	rep movsb
	mov eax,PLUGIN_VERSION

ret
endp

proc ODBG_Plugininit c ollydbgversion,hw,features
	cmp [ollydbgversion],PLUGIN_VERSION
	    jb ODBG_Plugininit_BadVersion
	mov edx,[hw]
	mov [plughw],edx

	mov DWORD [codesecdesc.memname],'.tex'
	mov DWORD [codesecdesc.memname+4],'t'

	mov DWORD [methodssecdesc.memname],'.rda'
	mov DWORD [methodssecdesc.memname+4],'ta'

	mov DWORD [stringssecdesc.memname],'.dat'
	mov DWORD [stringssecdesc.memname+4],'a'
	xor eax,eax
ret

     ODBG_Plugininit_BadVersion:
	mov eax,-1
ret
endp

proc ODBG_Pluginmenu c uses esi edi, origin,thedata,item

	cmp [origin],PM_MAIN
	    jnz ODBG_Pluginmenu_other
	mov esi,menutext
	mov edi,[thedata]
	mov ecx,(menutext_end-menutext)
	rep movsb
	mov eax,1

ret

     ODBG_Pluginmenu_other:
	xor eax,eax

ret
endp

align 16
ODBG_Pluginreset:
ret

align 16
ODBG_Pluginclose:
	xor eax,eax
ret

align 16
ODBG_Plugindestroy:
ret

proc ODBG_Pluginaction c uses esi edi ebx,origin,action,item
local secsleft:DWORD

     mov eax,[action]
     cmp eax,0
	 jz ODBG_Pluginaction_MAIN
     cmp eax,1
	 jz ODBG_Pluginaction_LABELINCLUDE_ADDR1
     cmp eax,2
	 jz ODBG_Pluginaction_LABELINCLUDE_ADDR2
     cmp eax,3
	 jz ODBG_Pluginaction_LABELINCLUDE_ADDR3
     cmp eax,4
	 jz ODBG_Pluginaction_LABELINCLUDE_ADDR4
     cmp eax,5
	 jz ODBG_Pluginaction_ABOUT
ret

;===========================================================
ODBG_Pluginaction_ABOUT:
;===========================================================
     invoke MessageBox,0,abouttext,msgboxtitle1,0

ret

;===========================================================
ODBG_Pluginaction_MAIN:
;===========================================================
;initialize vars
     xor eax,eax
     mov [codesecdesc.baseaddr],eax
     mov [methodssecdesc.baseaddr],eax
     mov [stringssecdesc.baseaddr],eax
     mov [codesecdesc.endaddr],eax
     mov [methodssecdesc.endaddr],eax
     mov [stringssecdesc.endaddr],eax
     mov [codesecdesc.size],eax
     mov [methodssecdesc.size],eax
     mov [stringssecdesc.size],eax
     mov [methodstemp],eax
     mov [stringstemp],eax
     mov [vtableclasscount],eax
     mov [methodscount],eax

;get main process base address
     invoke Plugingetvalue,VAL_MAINBASE
     add esp,4
     test eax,eax
	  jz ODBG_Pluginaction_MAIN_CouldNotGetMainBaseAddr
     mov [mainprocessbaseaddr],eax

;get memory blocks
     invoke Plugingetvalue,VAL_MEMORY
     add esp,4
     test eax,eax
	  jz ODBG_Pluginaction_MAIN_CouldNotGetMemInfo
     mov edx,eax
     mov ebx,[edx+t_table.data.data]
     mov esi,[edx+t_table.data.n]
     test esi,esi
	  jz ODBG_Pluginaction_MAIN_NoSecs

;find 3 used memory blocks
     mov [secsleft],3
     ODBG_Pluginaction_MAIN_GetSectionsLoop:

	 push esi
	 push edx
	 CMPMEMSECTSANDSET codesecdesc,[secsleft]
	 CMPMEMSECTSANDSET methodssecdesc,[secsleft]
	 CMPMEMSECTSANDSET stringssecdesc,[secsleft]
	 pop edx
	 pop esi

     cmp [secsleft],0
	 jz ODBG_Pluginaction_MAIN_GetSectionsLoop_Exit

     add ebx,[edx+t_table.data.itemsize]
     dec esi
	 jnz ODBG_Pluginaction_MAIN_GetSectionsLoop

     cmp [secsleft],0
	 jnz ODBG_Pluginaction_MAIN_MissingSecs

     ODBG_Pluginaction_MAIN_GetSectionsLoop_Exit:

;read methods and strings memory blocks
     mov eax,[methodssecdesc.size]
     add eax,8				;for 'safety' padding 0's during scan
     invoke LocalAlloc,LMEM_FIXED,eax
     test eax,eax
	  jz ODBG_Pluginaction_MAIN_OutOfMem
     mov [methodstemp],eax
     add eax,[methodssecdesc.size]
     xor ecx,ecx
     mov [eax],ecx
     mov [eax+4],ecx

     mov eax,[stringssecdesc.size]
     add eax,4
     invoke LocalAlloc,LMEM_FIXED,eax
     test eax,eax
	  jz ODBG_Pluginaction_MAIN_OutOfMem
     mov [stringstemp],eax
     add eax,[stringssecdesc.size]
     mov DWORD [eax],0

     invoke Readmemory,[methodstemp],[methodssecdesc.baseaddr],\
			 [methodssecdesc.size],MM_RESILENT
     add esp,16
     test eax,eax
	  jz ODBG_Pluginaction_MAIN_CouldNotRead

     invoke Readmemory,[stringstemp],[stringssecdesc.baseaddr],\
			 [stringssecdesc.size],MM_RESILENT
     add esp,16
     test eax,eax
	  jz ODBG_Pluginaction_MAIN_CouldNotRead

;scan through VTable methods buffer for potential pointers
;and add pointers as found
     mov edx,[methodssecdesc.size]

     lea eax,[edx-28h]			;approximate
     mov [methodssecpreendsize],eax

     mov esi,[methodstemp]
     add edx,esi
     mov [methodstempend],edx

     mov eax,[stringssecdesc.size]
     sub eax,16
     mov [stringssecpreendsize],eax

     ODBG_Pluginaction_MAIN_SCANLOOP:

  ;pre-vtable pointer
     mov ebx,[esi]
     sub ebx,[methodssecdesc.baseaddr]
	 jb VTablePrePointerNotInMethodsSection
     cmp ebx,[methodssecpreendsize]
	 ja VTablePrePointerNotInMethodsSection

  ;first method
     mov edx,[esi+4]
     cmp edx,[codesecdesc.baseaddr]
	 jb VTableFirstMethodNotInCodeSection
     cmp edx,[codesecdesc.endaddr]
	 jnb VTableFirstMethodNotInCodeSection

  ;get pre-vtable pointer into loaded buffer
     add ebx,[methodstemp]
  ;vtable sub-pointer
     mov edi,[ebx+0Ch]
     sub edi,[stringssecdesc.baseaddr]
	 jb VTableSubPointerNotInStringsSection
     cmp edi,[stringssecpreendsize]
	 jnb VTableSubPointerNotInStringsSection

  ;test label's VTable, make sure is in methods section
     add edi,[stringstemp]
     mov edx,[edi]
     mov eax,[methodssecdesc.endaddr]
     cmp edx,[methodssecdesc.baseaddr]
	 jb VTableFirstMethodNotInCodeSection
     sub eax,4
     cmp edx,eax
	 ja VTableFirstMethodNotInCodeSection

  ;get label name and unmangle
     ;mov ecx,edi
     ;invoke type_info_constr
     mov ecx,edi
     invoke type_info_name
     test eax,eax
	  jnz Demangle_Success
     push edi
     push esi
     add edi,8
     lea esi,[edi+4]
     mov edi,temp_buf
     mov BYTE [edi],'I'
     inc edi
     call TransferString
     mov DWORD [edi-2],0
     pop esi
     pop edi
     jmp UsedInterfaceNotation
     Demangle_Success:
     push edi
     push esi
     mov esi,eax
     mov edi,temp_buf
     call TransferString
     pop esi
     pop edi

     invoke free,[edi+4]	;release class name
     add esp,4
     mov DWORD [edi+4],0
     UsedInterfaceNotation:

     ;mov eax,[edi]
     ;mov ecx,edi
     ;call DWORD [eax]

     lea eax,[esi+4]			 ;convert esi to true vtable address
     sub eax,[methodstemp]
     add eax,[methodssecdesc.baseaddr]
     mov [tempvtableaddr],eax
     invoke Quickinsertname,eax,NM_LABEL,temp_buf
     add esp,12
     cmp eax,-1
	 jz Quickinsertname_FAIL_A
	 inc [vtableclasscount]
     Quickinsertname_FAIL_A:

  ;mov esi past current vtable, since valid
     mov ecx,1
     add esi,8
     ODBG_Pluginaction_MAIN_SUBLOOP:
     mov edx,[esi]
     cmp edx,[codesecdesc.baseaddr]
	 jb ODBG_Pluginaction_MAIN_SUBLOOP_END
     cmp edx,[codesecdesc.endaddr]
	 jnb ODBG_Pluginaction_MAIN_SUBLOOP_END
     inc ecx
     add esi,4
     jmp ODBG_Pluginaction_MAIN_SUBLOOP
     ODBG_Pluginaction_MAIN_SUBLOOP_END:

     cmp eax,-1
	 jz Quickinsertname_FAIL_B
     add [methodscount],ecx
     Quickinsertname_FAIL_B:

  ;print method count and unmangled string as comment
     lea eax,[edi+8]
     invoke wsprintf,temp_buf,vtablemethodscntstr,ecx,eax
     add esp,16

     invoke Quickinsertname,[tempvtableaddr],NM_COMMENT,temp_buf
     add esp,12

     jmp Continue_Loop_A		;skip +4 on esi, can cause missed VTables when close together

  ;continue loop
     VTableSubPointerNotInStringsSection:
     VTableFirstMethodNotInCodeSection:
     VTablePrePointerNotInMethodsSection:
     add esi,4
     Continue_Loop_A:

     cmp esi,[methodstempend]
	 jb ODBG_Pluginaction_MAIN_SCANLOOP

;print confirmation message
     push ebp
     mov ebp,esp
     invoke wsprintf,temp_buf,errmsgsuccess,\
		     codesecdesc.memname,[codesecdesc.baseaddr],[codesecdesc.size],\
		     methodssecdesc.memname,[methodssecdesc.baseaddr],[methodssecdesc.size],\
		     stringssecdesc.memname,[stringssecdesc.baseaddr],[stringssecdesc.size],\
		     [vtableclasscount],[methodscount]

     mov esp,ebp
     pop ebp

     invoke MessageBox,0,temp_buf,msgboxtitle1,MB_YESNO
     cmp eax,IDNO
	 jz ODBG_Pluginaction_MAIN_DisregardLabels

     invoke Mergequicknames
     invoke Redrawdisassembler
     LOCALRELEASE [methodstemp]
     LOCALRELEASE [stringstemp]

ret

ODBG_Pluginaction_MAIN_DisregardLabels:

     invoke Discardquicknames
     LOCALRELEASE [methodstemp]
     LOCALRELEASE [stringstemp]
ret

ODBG_Pluginaction_MAIN_CouldNotGetMainBaseAddr:
     invoke MessageBox,0,errmsgnomainbase,msgboxtitle1,0
ret

ODBG_Pluginaction_MAIN_CouldNotGetMemInfo:
     invoke MessageBox,0,errmsgnomeminfo,msgboxtitle1,0
ret

ODBG_Pluginaction_MAIN_NoSecs:
     invoke MessageBox,0,errmsgnosecs,msgboxtitle1,0
ret

ODBG_Pluginaction_MAIN_MissingSecs:
     invoke MessageBox,0,errmsgmissingsecs,msgboxtitle1,0
ret

ODBG_Pluginaction_MAIN_OutOfMem:
     LOCALRELEASE [methodstemp]
     LOCALRELEASE [stringstemp]
     invoke MessageBox,0,errmsgoutofmem,msgboxtitle1,0
ret

ODBG_Pluginaction_MAIN_CouldNotRead:
     LOCALRELEASE [methodstemp]
     LOCALRELEASE [stringstemp]
     invoke MessageBox,0,errmsgbadread,msgboxtitle1,0
ret


;===========================================================
ODBG_Pluginaction_LABELINCLUDE_ADDR1:
     mov [address_set_number],1
     mov [address_set_message], addrsetmsg_1
jmp ODBG_Pluginaction_LABELINCLUDE
ODBG_Pluginaction_LABELINCLUDE_ADDR2:
     mov [address_set_number],2
     mov [address_set_message], addrsetmsg_2
jmp ODBG_Pluginaction_LABELINCLUDE
ODBG_Pluginaction_LABELINCLUDE_ADDR3:
     mov [address_set_number],3
     mov [address_set_message], addrsetmsg_3
jmp ODBG_Pluginaction_LABELINCLUDE
ODBG_Pluginaction_LABELINCLUDE_ADDR4:
     mov [address_set_number],4
     mov [address_set_message], addrsetmsg_4
;jmp ODBG_Pluginaction_LABELINCLUDE
;===========================================================
ODBG_Pluginaction_LABELINCLUDE:
;===========================================================
;use local labels here

  ;confirm label add
     invoke MessageBox,0,[address_set_message],msgboxtitle1,MB_YESNO
     cmp eax,IDNO
	 jz .cancelinclude

  ;find first include file
     xor eax,eax
     mov [numregisteredlabels],eax
     mov [numscannedfiles],eax
     mov [searchhandle],eax

     invoke FindFirstFile,searchpathstring,finddatabuf
     cmp eax,INVALID_HANDLE_VALUE
	 jz .endinclude
     mov [searchhandle],eax

  .findallincludefilesloop:
  ;search current file for labels
     push esi
     push edi
     mov esi,finddatabuf.cFileName
     mov edi,lastfilename
     call TransferString
     pop edi
     pop esi
     mov [srcfilebuf],0
     stdcall ReadFullFileIntoBuffer,lastfiledirpart,2,0
     test eax,eax
	  jz .couldnotopenorreadfile
     mov [srcfilebuf],eax
     mov [srcfilebufsize],ecx
     mov WORD [eax+ecx],CTRL_CHAR_RETURNFULL
     inc [numscannedfiles]
     stdcall LABELINCLUDE_MAINSCAN
     test eax,eax
	  jz .mainscanerror
     invoke LocalFree,[srcfilebuf]
     invoke FindNextFile,[searchhandle],finddatabuf
     test eax,eax
	  jz .endinclude
     jmp .findallincludefilesloop

.endinclude:	 ;print number of registered labels as success message

  ;release search handle (if exists)
     FREEIFNOTNULL [searchhandle],FindClose

  ;merge quick-inserted label names (if any)
     cmp [numregisteredlabels],0
	  jz @f
     invoke Mergequicknames
     @@:
     invoke Redrawdisassembler

  ;print success msg
     mov edi,temp_buf
     cinvoke wsprintf,edi,successlabelinclude,[numscannedfiles],[numregisteredlabels]
     invoke MessageBox,0,edi,msgboxtitle1,0

.cancelinclude:
ret

.couldnotopenorreadfile: ;prints file name
     FREEIFNOTNULL [searchhandle],FindClose
     FREEIFNOTNULL [srcfilebuf],LocalFree
     cmp [numregisteredlabels],0
	  jz @f
     invoke Discardquicknames
     @@:
     mov edi,temp_buf
     cinvoke wsprintf,edi,errormsgfiletemplate,lastfilename
     invoke MessageBox,0,edi,msgboxtitle1,0
ret

.mainscanerror:
     FREEIFNOTNULL [searchhandle],FindClose
     FREEIFNOTNULL [srcfilebuf],LocalFree
     cmp [numregisteredlabels],0
	  jz @f
     invoke Discardquicknames
     @@:
     mov edi,temp_buf
     cinvoke wsprintf,edi,errormsgmainscantemp,lastfilename,[mainscanlasterror]
     invoke MessageBox,0,edi,msgboxtitle1,0
ret
endp

;============================================================
proc LABELINCLUDE_MAINSCAN uses ebx esi edi
;============================================================

     mov esi,[srcfilebuf]
     mov edi,[srcfilebufsize]
     add edi,esi

     .mainscanloop:
  ;find '#label' keyword
     stdcall FindNextSymbolInLine,esi
     test eax,eax
     mov esi,ecx
	 jz .endofline
     mov edx,ecx
     sub edx,eax
     cmp edx,LABEL_DEF_SIZE
	 jnz .gotoendofline
     cmp DWORD [eax],'#lab'
	 jnz .gotoendofline
     cmp WORD [eax+4],'el'
	 jnz .gotoendofline
  ;find label name and save
     stdcall FindNextSymbolInLine,esi
     test eax,eax
     mov esi,ecx
	 jz .endofline
     mov edx,ecx
     sub edx,eax
     cmp edx,1
	 jz .gotoendofline	 ;labels must be over one byte
     cmp edx,MAX_SYMBOL_SIZE
	 ja .gotoendofline
     push esi
     push edi
     mov esi,eax
     mov edi,symbolbuf
     mov ecx,edx
     rep movsb
     mov BYTE [edi],0
     pop edi
     pop esi
  ;find '=' char
     stdcall FindNextSymbolInLine,esi
     test eax,eax
     mov esi,ecx
	 jz .endofline
     mov edx,ecx
     sub edx,eax
     cmp edx,1
	 jnz .gotoendofline
     cmp BYTE [eax],'='
	 jnz .gotoendofline
  ;loop: find address string
	 mov ebx,[address_set_number]
	 .findlabeladdrloop:
	 stdcall FindNextSymbolInLine,esi
	 test eax,eax
	 mov esi,ecx
	     jz .endofline
	 mov edx,ecx
	 sub edx,eax
	 cmp edx,1
	     jnz @f
	 cmp BYTE [eax],','
	     jz .gotoendofline
	 @@:
	 dec ebx
	     jz .checksymboladdress
	 stdcall FindNextSymbolInLine,esi
	 test eax,eax
	 mov esi,ecx
	     jz .endofline
	 mov edx,ecx
	 sub edx,eax
	 cmp edx,1
	     jnz .gotoendofline
	 cmp BYTE [eax],','
	     jnz .gotoendofline
	 jmp .findlabeladdrloop
     .checksymboladdress: ;size in edx, address in eax
     cmp edx,1		     ;if address is '0', it won't be registered anyway
	 jz .gotoendofline
  ;convert address string
     mov ebx,lasthexaddress
     push ebp
     mov DWORD [ebx],0
     mov ebp,esp
     invoke sscanf,eax,hex_template,ebx
     mov esp,ebp
     pop ebp
     mov edx,[ebx]
     test edx,edx
	  jz .gotoendofline	;do not register label if address is null
  ;here, add label to quick names
     cinvoke Quickinsertname,edx,NM_LABEL,symbolbuf
     cmp eax,-1
	 jz .quickerrorlabel
     cinvoke Quickinsertname,[ebx],NM_COMMENT,symbolbuf
     cmp eax,-1
	 jz .quickerrorcomment
     inc [numregisteredlabels]

     .gotoendofline:
     stdcall GoToNextLine

     .endofline:
     cmp esi,edi
	 jb .mainscanloop

     mov eax,TRUE
ret

.quickerrorlabel:
     mov [mainscanlasterror],error_quicklabel
     xor eax,eax
ret

.quickerrorcomment:
     mov [mainscanlasterror],error_quickcomment
     xor eax,eax
ret
endp


align 16
;============================================================
TransferString: 	;esi=source, edi=dest., destroyed: esi,edi, al
;============================================================
TransferStringLoop: ;edi points to dest.'s null-terminator (BYTE [edi] = 0)
     mov al,[esi]
     mov [edi],al	      ;transfer/append string
     test al,al
	  jz End_TransferStringLoop
     inc esi
     inc edi
     jmp TransferStringLoop
End_TransferStringLoop:
ret

;===============================================================
proc ReadFullFileIntoBuffer uses ebx edi esi, lpFilename, NumberOfPaddingBytes, MinimumFileSize
;===============================================================
;returns eax = GENERAL_PROC_ERROR error, eax = buffer for file if success, ecx = file size (without padding bytes)
;ebx = file handle

	xor ebx,ebx
	xor edi,edi
	invoke CreateFile,[lpFilename],GENERIC_READ,FILE_SHARE_READ,0,\
			  OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0

	cmp eax,INVALID_HANDLE_VALUE
	    jz .OpenFullFileFail
	mov ebx,eax

	invoke GetFileSize,ebx,0
	cmp eax,INVALID_HANDLE_VALUE
	    jz .OpenFullFileFail
	cmp eax,0
	    jz .OpenFullFileFail
	cmp eax,[MinimumFileSize]
	    jb .OpenFullFileFail
	mov esi,eax

	invoke SetFilePointer,ebx,0,0,FILE_BEGIN
	cmp eax,INVALID_HANDLE_VALUE
	    jz .OpenFullFileFail

	mov eax,[NumberOfPaddingBytes]
	add eax,esi
	invoke LocalAlloc,LMEM_FIXED,eax
	test eax,eax
	     jz .OpenFullFileFail
	mov edi,eax

	push eax
	mov edx,esp
	invoke ReadFile,ebx,edi,esi,edx,0
	test eax,eax
	pop ecx
	    jz .OpenFullFileFail
	cmp ecx,esi
	    jnz .OpenFullFileFail

	invoke CloseHandle,ebx

	mov ecx,esi
	mov eax,edi
ret

.OpenFullFileFail:

test edi,edi
     jz @f
invoke LocalFree,edi
@@:

test ebx,ebx
     jz @f
invoke CloseHandle,ebx
@@:

xor eax,eax
xor ecx,ecx
ret
endp


;===============================================================
proc FindNextSymbolInLine uses esi edi, lpBuffer
;===============================================================
;EXCLUDES COMMENTS
;returns pointer to symbol in eax + pointer to char after end of symbol in ecx
; (difference = symbol size)
;or null in eax if none before line end or before comment
;    + pointer to next line in ecx
;does not check for boundaries
;character following symbol must be a return, space, tab, or comment character,
;so if this proc is called consecutively using the address returned in ecx without
;modification, it will detect the space/tab/return/comment char from the first
;call without problem (can be called iteratively)

	mov esi,[lpBuffer]
	dec esi
	.findsymbolstartloop:
	inc esi
	mov al,[esi]
	cmp al,CTRL_CHAR_SPACE
	    jz .findsymbolstartloop
	cmp al,CTRL_CHAR_TAB
	    jz .findsymbolstartloop
	cmp al,CTRL_CHAR_RETURN
	    jz .nosymbolfound_return
	cmp al,CTRL_CHAR_FEED
	    jz .nosymbolfound_feed
	cmp al,CTRL_CHAR_COMMENT
	    jz .nosymbol_comment
	cmp al,CTRL_CHAR_COMMA
	    jz .symbolfound_comma

;find symbol end + length
	mov ecx,esi
	.findsymbolendloop:
	inc ecx
	mov al,[ecx]
	cmp al,CTRL_CHAR_SPACE
	    jz .findsymbolendloop_found
	cmp al,CTRL_CHAR_TAB
	    jz .findsymbolendloop_found
	cmp al,CTRL_CHAR_RETURN
	    jz .findsymbolendloop_found
	cmp al,CTRL_CHAR_FEED
	    jz .findsymbolendloop_found
	cmp al,CTRL_CHAR_COMMA
	    jz .findsymbolendloop_found
	cmp al,CTRL_CHAR_COMMENT
	    jnz .findsymbolendloop

	.findsymbolendloop_found:

	mov eax,esi
       ;ecx = pointer to next char after symbol
ret

.nosymbolfound_return:
	CHECKFORFEEDCHAR esi
	mov ecx,esi
	mov eax,GENERAL_PROC_ERROR
ret

.nosymbolfound_feed:
	lea ecx,[esi+1]
	mov eax,GENERAL_PROC_ERROR
ret

.nosymbol_comment:
	inc esi
	call GoToNextLine
	mov ecx,esi
	mov eax,GENERAL_PROC_ERROR
ret

.symbolfound_comma:
	mov eax,esi
	lea ecx,[esi+1]
ret
endp

align 16
;===============================================================
GoToNextLine:	;esi = pointer  destroys esi,eax
;===============================================================

	.scanloop:
	mov al,[esi]
	cmp al,CTRL_CHAR_RETURN
	    jz .returncharfound
	cmp al,CTRL_CHAR_FEED
	    jz .feedcharfound
	inc esi
	jmp .scanloop

.feedcharfound:
	inc esi
ret

.returncharfound:
	CHECKFORFEEDCHAR esi
ret

;===========================================================
section '.data' data readable writeable
;===========================================================

dllhandle		dd	0
plughw			dd	0

align 4
pluginname		db	"TresVTableIDLabels",0
     pluginname_end:

align 4
menutext:
			db	"0 Create &Class Labels|"
			db	"1 Create &LABELINCLUDE Labels address set 1 (P611),"
			db	"2 Create &LABELINCLUDE Labels address set 2 (K611),"
			db	"3 Create &LABELINCLUDE Labels address set 3 (P511),"
			db	"4 Create &LABELINCLUDE Labels address set 4 (DEMO)|"
			db	"5 &About"
			db	0
menutext_end:


align 4
abouttext:
			db	"Trespasser VTable Identifier and Labeler v",TRES_PLUGIN_VERSION,0Dh,0Ah
			db	"trespasserhacks@yahoo.com",0Dh,0Ah,0Dh,0Ah
			db	"To use, load a valid Trespasser executable",0Dh,0Ah
			db	"using Ollydbg 1.10 and choose 'Create Class Labels'",0Dh,0Ah
			db	"from the plugin menu. Then, select 'Yes'."
			db	0

mainprocessbaseaddr	dd	0
codesecdesc		memsectdesc
methodssecdesc		memsectdesc
stringssecdesc		memsectdesc
methodssecpreendsize	dd	0
stringssecpreendsize	dd	0

methodstemp		dd	0
stringstemp		dd	0
methodstempend		dd	0

vtableclasscount	dd	0
methodscount		dd	0

tempvtableaddr		dd	0

msgboxtitle1		db	"TresVTableIDLabels",0
errmsgnomainbase	db	"Error: No debugged application (could not get process base address).",0
errmsgnomeminfo 	db	"Error: No debugged application (could not get memory info from debugger).",0
errmsgnosecs		db	"Error: No debugged application (0 memory sections).",0
errmsgmissingsecs	db	"Error: Could not find all memory section names.",0
errmsgoutofmem		db	"Error: Out of memory.",0
errmsgbadread		db	"Error: Could not read memory blocks from debugged application.",0
errmsgsuccess		db	"Successfully scanned sections in main debuggee:",0Dh,0Ah
			db	"Code section:",0Dh,0Ah
			db	"name: %s; address: 0x%.8X, size: 0x%.8X",0Dh,0Ah
			db	"VTable method addresses section:",0Dh,0Ah
			db	"name: %s; address: 0x%.8X, size: 0x%.8X",0Dh,0Ah
			db	"Class string names section:",0Dh,0Ah
			db	"name: %s; address: 0x%.8X, size: 0x%.8X",0Dh,0Ah
			db	0Dh,0Ah
			db	"Total number of VTables/classes/labels: %u",0Dh,0Ah
			db	"Total number of methods: %u",0Dh,0Ah
			db	0Dh,0Ah
			db	"Add all found class names as user labels for debuggee?",0Dh,0Ah
			db	0
vtablemethodscntstr	db	"%u methods in VTable, mangled name: %s",0

align 4
temp_buf		dd	200 dup 0

align 4
;LABELINCLUDE data
address_set_number	dd	0      ;can be 1,2,3,4
address_set_message	dd	0
lasthexaddress		dd	0
numregisteredlabels	dd	0
numscannedfiles 	dd	0
searchhandle		dd	0
finddatabuf		FINDDATA
srcfilebuf		dd	0
srcfilebufsize		dd	0
mainscanlasterror	dd	0
lastfiledirpart 	db	"LABELINCLUDE\"
lastfilename		db	MAX_PATH dup 0
symbolbuf		db	(MAX_SYMBOL_SIZE+1) dup 0


addrsetmsg_1		db	"Are you sure you want to create LABELINCLUDE labels for address set 1 (P611)?",0
addrsetmsg_2		db	"Are you sure you want to create LABELINCLUDE labels for address set 2 (K611)?",0
addrsetmsg_3		db	"Are you sure you want to create LABELINCLUDE labels for address set 3 (P511)?",0
addrsetmsg_4		db	"Are you sure you want to create LABELINCLUDE labels for address set 4 (DEMO)?",0
searchpathstring	db	"LABELINCLUDE\*.inc",0
errormsgfiletemplate	db	"Could not open, read, or allocate memory for file:",0Dh,0Ah
			db	"%s",0
errormsgmainscantemp	db	"Error while scanning include file:",0Dh,0Ah
			db	"%s",0Dh,0Ah
			db	"%s",0
hex_template		db	"%X",0
error_quicklabel	db	"Could insert label name as label.",0
error_quickcomment	db	"Could insert label name as comment.",0
successlabelinclude	db	"Operation completed successfully.",0Dh,0Ah
			db	"Number of include files scanned: %u",0Dh,0Ah
			db	"Number of labels registered: %u",0

;===========================================================
section '.idata' import data readable writeable
;===========================================================

  library kernel,'KERNEL32.DLL',\
	  msvcrt,'MSVCRT.DLL',\
	  ollydbg,'OLLYDBG.EXE',\
	  user,'USER32.DLL'

  import kernel,\
	 CloseHandle,'CloseHandle',\
	 CreateFile,'CreateFileA',\
	 FindClose,'FindClose',\
	 FindFirstFile,'FindFirstFileA',\
	 FindNextFile,'FindNextFileA',\
	 GetFileSize,'GetFileSize',\
	 LocalAlloc,"LocalAlloc",\
	 LocalFree,"LocalFree",\
	 ReadFile,'ReadFile',\
	 SetFilePointer,'SetFilePointer'

  import msvcrt,\
	 type_info_constr,"??1type_info@@UAE@XZ",\
	 type_info_name,"?name@type_info@@QBEPBDXZ",\
	 free,"free",\
	 msize,"_msize",\
	 rand,"rand",\
	 sprintf,"sprintf",\
	 srand,"srand",\
	 sscanf,"sscanf",\
	 time,"time",\
	 YAPAXI,"??2@YAPAXI@Z"

  import ollydbg,\
	 Demanglename,'_Demanglename',\
	 Discardquicknames,'_Discardquicknames',\
	 Mergequicknames,'_Mergequicknames',\
	 Plugingetvalue,'_Plugingetvalue',\
	 Quickinsertname,'_Quickinsertname',\
	 Readmemory,'_Readmemory',\
	 Redrawdisassembler,'_Redrawdisassembler'

  import user,\
	 MessageBox,'MessageBoxA',\
	 wsprintf,"wsprintfA"

;===========================================================
section '.edata' export data readable
;===========================================================

  export 'tresvtableidlabels.dll',\
	 ODBG_Pluginaction,'_ODBG_Pluginaction',\
	 ODBG_Pluginclose,'_ODBG_Pluginclose',\
	 ODBG_Plugindata,'_ODBG_Plugindata',\
	 ODBG_Plugindestroy,'_ODBG_Plugindestroy',\
	 ODBG_Plugininit,'_ODBG_Plugininit',\
	 ODBG_Pluginmenu,'_ODBG_Pluginmenu',\
	 ODBG_Pluginreset,'_ODBG_Pluginreset'

;===========================================================
section '.reloc' fixups data discardable
;===========================================================