; Compile using FASM. Version used for last release: 1.66 (May 7, 2006)

;=====================================================
; DEMANGLING UTILITY DLL
;=====================================================

DEMANGLER_VERSION		      equ     '1.0'


;=================================================================
format PE GUI 4.0 DLL at 1000000h
entry DllEntryPoint
;=================================================================

include '%fasminc%\WIN32A.INC'

MACRO FINDSTRINGEND reg1 {
local .scanloop,.endfound

	cmp BYTE [reg1],0
	  jz .endfound
	.scanloop:
	inc reg1
	cmp BYTE [reg1],0
	    jnz .scanloop
	.endfound:

      }


;=================================================================
section '.code' code readable executable
;=================================================================

;-----------------------------------
proc DllEntryPoint hinstDLL, fdwReason, lpvReserved
;-----------------------------------

	mov eax,TRUE

	cmp [fdwReason],DLL_PROCESS_ATTACH
	jz .dllload

ret

.dllload:

	mov ecx,[hinstDLL]
	mov [dllhandle],ecx

ret
endp



;-----------------------------------
proc UnmangleName uses esi ebx edi, lpString
;-----------------------------------

 ; move string to temporary type_info class structure (hacked emulation)

	mov ebx,[lpString]
	FINDSTRINGEND ebx
	mov edx,[lpString]
	inc ebx
	sub ebx,edx

	lea esi,[ebx+3+12]	 ; +3 for string align, +12 for vtable pointer, ref count, and terminating DWORD
	and esi,(not 3) 	 ; align to dword
	cinvoke alloc,esi
	test eax,eax
	mov ecx,0
	jz .exit

	mov [eax],ecx
	mov [eax+4],ecx
	mov [eax+esi-8],ecx
	mov [eax+esi-4],ecx

	mov ecx,ebx
	mov esi,[lpString]
	and ecx,(not 3)
	lea edi,[eax+8]
	shr ecx,2
	rep movsd
	mov ecx,ebx
	and ecx,3
	rep movsb

	mov esi,eax
	mov ecx,esi
	cinvoke type_info_name		; returns unmangled name in allocated buffer

	mov edi,eax

	cinvoke free,esi

	mov eax,edi

.exit:
ret
endp

;-----------------------------------
proc FreeName lpString
;-----------------------------------

	cinvoke free,[lpString]

ret
endp

;=================================================================
section '.data' data readable writeable
;=================================================================
; readable/writable data

dllhandle	dd	0


;=================================================================
section '.idata' import data readable writeable
;=================================================================
; imported DLL functions

  library msvcrt,'MSVCRT.DLL'

  import msvcrt,\
	 free,"free",\
	 type_info_constr,"??1type_info@@UAE@XZ",\
	 type_info_name,"?name@type_info@@QBEPBDXZ",\
	 alloc,"??2@YAPAXI@Z"



;=================================================================
section '.edata' export data readable
;=================================================================

	export "UNMANGLE.DLL",\
		UnmangleName,"UnmangleName",\
		FreeName,"FreeName"

;=================================================================
section '.rsrc' resource data readable
;=================================================================
; resources (small bitmaps, dll version info, etc.)

	directory RT_VERSION,versions

	resource versions,1,LANG_NEUTRAL,version

	versioninfo version,VOS__WINDOWS32,VFT_APP,VFT2_UNKNOWN,LANG_ENGLISH+SUBLANG_DEFAULT,0,\
		    'FileDescription','Part of the ATX Trespasser modification',\
		    'LegalCopyright','Free, open source.',\
		    'FileVersion',DEMANGLER_VERSION,\
		    'ProductVersion',DEMANGLER_VERSION,\
		    'OriginalFilename','DEMANGLER.DLL'

;=================================================================
section '.reloc' fixups data discardable readable
;=================================================================